Getting Started with Push the Freakin' Button - Pro (PTFB Pro)

Getting Started with PTFB Pro

PTFB Pro is a utility for automatically handling confirmation screens and other windows that interrupt your workflow. Running on Windows 98, NT4(SP6), 2000, XP and Server 2003, it quietly keeps watch from the system tray. When it sees a window that you have previously targeted, it carries out the button and key presses that you have defined, saving you time, irritation and finger-wear.

The following topics tell you how to get up and running quickly, and what to do if you need help:

Overview

How To...

Exploring the User Interface

Getting Help

Automating Button Pushing - The Basics

Recording and Playback of Macros

Setting up Notifications

Working with a locked computer / locking screensaver

Troubleshooting


Push the Freakin' Button - Pro (PTFB Pro) : Overview

PTFB Pro : Overview

PTFB Pro is a mouse auto-clicker and macro recorder for automatically handling confirmation screens and other windows that interrupt your workflow. It quietly keeps watch from the system tray. When it sees a window that you have previously targeted, it carries out the button and key presses that you have defined, saving you time, irritation and finger-wear.

PTFB Pro's features include:

  • Automatic dismissal of irritating messages by simulating a button press.
  • Record and playback of complex sequences of mouse, key and other actions to automate repetitive tasks.
  • Macros and button presses can be set to trigger in a variety of ways:
    - when a target window appears
    - according to a repeating date/time schedule
    - user-definable hotkey
    - by command line directive
  • Edit macros easily and add custom commands to run scripts, programs and even other macros.
  • Notifications by log, email and command line to keep track of what actions have been carried out, and when.
  • Actions can run successfully even when your computer is locked, via the optional service component.
  • Highly configurable - define hotkeys for quickly enabling/disabling PTFB, change the defaults for new macros/presses, fine-tune target window recognition using regular expressions etc.

More Information

If you're completely new to PTFB, click here to read the "How To..." guide. It'll get you up and running quickly!

If you've just upgraded from version 2, please read the notes for version 2 users.


Notes for Version 2 Users

PTFB Pro 3 can be installed over the top of an existing version 2 installation. Doing this is the recommended approach, as it preserves all your existing single-press and macro (formerly "sequence") definitions.

Licensed users of version 2 will quickly notice that their registration name and key are no longer recognized! To obtain a version 3 license please visit the following web page: http://www.ptfbpro.com/upgrade.shtml.

Version 3 of PTFB Pro includes many new features and enhancements - here are the main changes from version 2:

  • Separate initial and repeat delays for both single presses and macros (sequences)
  • Ability to edit macros and insert custom commands (e.g. run command line, run other macro)
  • Window-less macros (operate on entire screen)
  • Greater speed range for macro playback (1/4 speed through to maximum possible)
  • New triggering options:
    - when target window appears (as before, but now with ability to confine actions to certain days/hours)
    - repeating day/time schedule (like Windows scheduler)
    - your own choice of hotkey
    - command line (an external program can tell PTFB to run a macro on demand)
  • Option to conceal macro contents from prying eyes
  • New items take a snapshot of the original target window, so you can always refresh you memory!
  • Ability to operate on minimized windows
  • Ability to handle multiple on-screen instances of the same target

Finally, please note that PTFB now uses the term "macro" instead of sequence. Now that PTFB Pro has a full set of macro-handling capabilities, we felt it was best to use the more conventional term.


How To...

This section guides you through a number of common tasks for PTFB Pro:

Automatically dismiss the Outlook security message ("A program is trying to access...")

Automatically dismiss a popup message (dialog) with a single-click

Automatically dismiss a system tray notification balloon

Automatically perform a series of mouse clicks and/or key presses when a dialog appears

Reduce the delay before PTFB Pro takes action

Make an action repeat

Get PTFB Pro to record or notify you about its actions

Get PTFB Pro to handle dialogs even when your PC is locked

Make PTFB Pro start automatically each time your computer starts up

Stop PTFB's activities

Automatically dismiss the Outlook security message ("A program is trying to access...")

This is done using a "Single Press" target, as follows.

When the offending Outlook security message next appears:

  1. Open up PTFB Pro's main window (click the blue mouse icon in the tray area of the taskbar when PTFB Pro is running)
  2. Click "Single Press"
  3. Move the hand cursor over the "Yes" button in the Outlook security message and click to define the target
  4. Press "Start Watching" in PTFB Pro to take care of the message

If you haven't changed PTFB Pro's settings, the new target will have a 1 second delay before it dismisses the Outlook warnings. If you'd rather have PTFB Pro handle the dialogs as fast as possible, you can reduce the delay to 0 seconds - here's how.

Finally, please bear in mind that Microsoft added this security feature to Outlook with the best of intentions. PTFB Pro can't discriminate between legitimate attempts to send email and the work of rogue scripts and viruses - if you use PTFB Pro to override the warning dialogs, you assume the associated risks.

Automatically dismiss a popup message (dialog) with a single-click

To do this, you'll need to open up PTFB Pro's main window and define a new "Single Press" target. Read the following section for a step-by-step guide: Automating Button Pushing - The Basics

Automatically dismiss a system tray notification balloon

Irritated by XP/Vista's balloon messages hovering over the system tray area? Use PTFB Pro's Single-Press facility to close them as soon as they appear. Click here for more details.

Automatically perform a series of mouse clicks and/or key presses when a dialog appears

When you want do do something more complicated than a single click, you need to define a Macro. In brief, the procedure for this is:

  1. Click "Macro" to create a new macro entry
  2. Tell PTFB Pro which window to watch for
  3. Carry out the tasks you want PTFB Pro to record
  4. Stop the recording (hit the Break key) and press "Start Watching" to put PTFB Pro to work

Here's a full step-by step guide to the whole process: Automating Execution of Macros - The Basics

Reduce the delay before PTFB Pro takes action

Unless you've already changed PTFB Pro's default settings, each new target you create starts out with a 1 second delay. This is for safety reasons - it lets you briefly see the target window just before PTFB Pro handles it for you.

You can raise the delay, or reduce it right down to zero seconds (almost instant, subject to the speed of your computer and current workload). To do this:

  1. Open up PTFB Pro's main window
  2. Double-click the target whose delay is to be changed. This will display its property sheet.
  3. Click on the "Triggers" tab to change to that page. Look for the field labeled"Initial Delay" near the top of the page, and set the delay to 0 seconds (or whatever you like, up to a maximum of 4 hours)
  4. Click OK on the sheet to save changes

For more details about this and other settings you can change for single press and macro items, please read the following sections:

Automating Button Pushing - Tweaking the Settings

Recording and Playback of Macros- Tweaking the Settings

Make an action repeat

Since PTFB Pro is primarily designed for dismissing irritating messages, it carries out an action only once each time it sees the target window. You can change this, and allow PTFB Pro to repeat the action as follows:

  1. Edit the target by double-clicking it in PTFB Pro's list
  2. Switch to the "Triggers" page
  3. Tick"Repeat After" near the top the page, and set the separate repeat delay (if necessary)
  4. Clicking "OK" to save changes

Macros offer additional options for repeated playback:

  • Open PTFB's main window, right-click on the macro on question and choose "Run Multiple Times" from the popup menu, OR
  • Select the macro in PTFB's main window and click Run repeatedly (or define a hotkey for the Run button and use that), OR
  • Edit the macro and wrap a REPEAT..LOOP around the existing actions.

For more details about this and other settings you can change for single press and macro items, please read the following sections:

Automating Button Pushing - Tweaking the Settings

Recording and Playback of Macros - Tweaking the Settings

Get PTFB Pro to record or notify you about its actions

To do this, you need to setup a notification on each of the targets you want to monitor. For more information please read the following section: Setting up Notifications

Get PTFB Pro to handle dialogs even when your PC is locked

By default, PTFB Pro can't handle dialogs that pop up while your PC is locked, but you can give PTFB Pro the ability to briefly unlock then re-lock your PC when action needs to be taken. To do so, you need to:

  1. Install the optional service component
  2. Set up PTFB Pro so that it can log back on tot he computer in your absence
  3. In the case of Windows, XP, make sure "Fast User Switching" is disabled

For more details, please read the following section: Working with a locked computer / locking screensaver

Make PTFB Pro start automatically each time your computer starts up

In the dim and distance past, this required the addition of a shortcut to the "Startup" group of the Start menu, but this is no longer necessary!

To set automatic start up:

  1. Open up PTFB Pro's main window (click the blue mouse icon in the tray area of the taskbar when PTFB Pro is running)
  2. Click the button marked "Options" and select "Configure..." from the resulting popup menu
  3. Tick "Run at startup" in the Miscellaneous section of the General page
  4. Press "Close" to save your changes

Note: if you have created a shortcut in the Startup group, then make choice between using that or the above method - don't use both, because PTFB will open its main window if a second attempt is made to run it while it's sitting minimized in the tray.

For more information, please read the section titled: PTFB Pro Configuration

Stop PTFB's activities

If you want to call a temporary halt to PTFB's activities, here's a quick run-down of how to do it.

To stop a macro in mid-playback, hold down the CTRL and ALT keys together, and tap the Escape key. This will abort macro playback, and bring up the Start menu.

To temporarily disable PTFB, either left-click its icon in the tray to open the main window, or right-click the icon and choose "Disable PTFB".

Remember you can also define a hotkey for enabling/disabling PTFB. In fact, if you're considering setting up a repeating item with zero delays, this is a must!

To disable a particular item, untick it in PTFB's main list - this prevents the item from firing for any and all triggers you've defined


Exploring the User Interface

The main window gives you fast access to PTFB Pro's key functions. It is displayed on the first run after installation, and thereafter by clicking on PTFB Pro's tray icon. The window starts out at its smallest possible size - don't forget that you can resize it using any of the standard Windows methods.

The various controls on the main window are described below. In its default configuration, hovering the mouse over any of these controls will display a helpful tooltip. Once you become experienced in using PTFB pro, you may wish to disable the tooltips - for details please read PTFB Pro Configuration.

Single Press

Click this if you want to create a new item that performs a single button press in a target window. It's the quickest way to get PTFB to dismiss unwanted confirmation messages and other irritations.

When you click this button, the cursor turns to a hand with an outstretched finger. Just move that finger directly over the button you want PTFB Pro to press and click again to create the new entry, or right-click (or hit the Escape key) to cancel.

For more details see Automating Button Pushing.

Macro

Use this to create an entry that will carry out a series of mouse and/or keyboard actions on a window. Creating a window-based macro is a two-stage process:

  1. Press "Macro" to change the cursor to a hand, then click on the target window.
  2. PTFB Pro will display its recording window. Carry out your required actions on the target, then tap the Pause/Break key on your keyboard or click "Stop" on the recording window.

PTFB Pro also supports the creation of a window-less macro, which is handy for certain special applications. To get a choice over the type of macro to create, press the right-hand side of the macro button, or click the Options button and select from the New Macro sub-menu.

For more details see Recording and Playback of Macros.

Tab Bar

When you first use PTFB Pro, all the macro and single-press items you create are held together in a single group. If you create additional groups then PTFB Pro displays a row of tabs above the list, to let you switch from one group to another. You can also force PTFB Pro to show the tab bar regardless of how many tabs (groups) there are.

For more information, please see the section on Organizing Macros and Single-Press Items into Groups.

List Box

The list box shows the macro and single-press items you have defined, and has various columns as described below. You can resize columns by dragging the dividers on the list header, and re-order columns by clicking and dragging column headers to the left or right.

By default, the list is sorted automatically to preserve alphabetical order. If you disable automatic sorting (see the section on PTFB Pro Configuration) you can order the list manually using drag and drop. You can also create new groups to help manage the items you create - for more information see the section on Organizing Macros and Single-Press Items into Groups.

The list allows more than one item to be selected, which makes it easier to move or delete multiple items in one go. You can also toggle multiple items on/off by selecting the items in question and tapping the space bar on your keyboard. To select multiple items, hold down the shift key (for contiguous selection) or ctrl key (for non-contiguous selection) as you click items in the list. Note however that certain functions (Run Macro, Edit) are only available when a single item is selected.

The list is subdivided into columns as follows:

On: shows whether the item is enabled or disabled - click on the checkbox by each item to toggle its state. This is the master switch for each item; a disabled item will not run no matter what trigger options have been selected.

Target Name: shows the name given to this entry. You can change the default name by selecting the list entry and clicking Edit..., or by double-clicking the item.

Log: indicates if the entry has any notifications (such as logging to text file, sending an email, or running a script or command). The presence of an additional asterisk icon in this column means that the notification may be disabled. For example, the entry may have an email notification, but all emails may be disabled via the PTFB Configuration screen.

Info: shows a little extra information to jog your memory about what the entry does. If the entry has an initial delay before action is taken (which is the default), the entry will start with the word "Wait" followed by an indication of how long the delay is, in seconds. To increase or decrease the delay, select the entry and press "Edit" (see below). You can also change the default delay applied to new entries - please see the section on PTFB Pro Configuration for more details.

Hovering the mouse over the list displays a tooltip with the following information:

- if the mouse is over a cell in the "Target Name" column, the tooltip displays the full item name and the comment, if any
- if the mouse is over a cell in the Log column, the tooltip displays information on the item's notifications, if any
- if the mouse is over a cell in the Info column, the tooltip displays the stock text from the underlying list cell, plus information about the various trigger options, including any assigned hotkey

You can disable the tooltips if you wish - please see the section on PTFB Pro Configuration for more details.

Run Macro

This is only available when PTFB's main window is open, and an enabled macro is selected in the list. It causes the macro to run immediately, regardless of what trigger options are set. Clicking the right-hand side of the button presents further options as follows.

Run Multiple Times: This runs the selected macro a given number of times in rapid succession. As an example, imagine you were doing a repetitive editing task on each line of a text file or spreadsheet. You could record a macro as you perform the task on the first line, then use Run Multiple to apply the macro to the remaining lines.

Set Hotkey: You can define a hotkey for the Run Macro function, allowing you to trigger the selected macro manually even when PTFB's window is obscured by others.

Clear Hotkey: Cancels the hotkey for the Run Macro function. The key sequence is now free to be used elsewhere in PTFB, or in other programs.

Edit...

This is only available when an item is selected in the list box. When clicked it displays properties for the selected item, allowing you to change the delay before PTFB Pro takes action, make target identification more/less strict, and so on. Double-clicking on a list entry has the same effect as selecting the entry and clicking Edit. For more details, please read Tweaking the Settings for single press entries, or the equivalent section for macros.

Delete

When one or more items are selected in the list, click Delete to remove them permanently. You will be asked to confirm this action (though you can bypass future confirmations by clicking "Do Not show this again"). Take care when deleting entries - once they're gone, they're gone!

Options

Clicking this button displays the Options menu, giving you access to PTFB Pro's main configuration dialog, links to PTFB Pro's website, and for users of older PTFB versions, a chance to import their existing target entries.

Start Watching

PTFB Pro will not take any automatic action while its main window is on-screen. Clicking "Start Watching" or the close box in the top-right corner closes the main window, minimizing PTFB Pro to the system tray. Once in this state, PTFB Pro is active, and will take appropriate action on any target windows it sees (subject to the trigger options you have set up).

Quit PTFB

This button, rather than the close box in the top-right corner, is used to quit PTFB Pro. Another way to quit PTFB Pro is to right-click on its tray icon and select Exit from the resulting menu.

Buy Now / Register

This button is only displayed on copies of PTFB Pro that have not yet been fully licensed. Clicking the button gives you details on how to purchase PTFB Pro and enter your license code.

Help

Displays this Help file.

System Tray Icon

PTFB Pro places a mouse-shaped icon in your system tray when it is running. This icon has a small "x" when PTFB is disabled, and carries a red border (see below) when a macro is playing or when an automated action is about to run.

Note that Windows XP sometimes hides tray icons to reclaim space for the taskbar. By default, PTFB Pro takes steps to defeat icon hiding. If you wish to change this setting, please open the configuration screen via the Options popup menu.


Getting Help

Options Menu

To access the Options menu, first open PTFB Pro's main window by clicking on the tray icon, then click on the Options button.

The Options menu contains the following commands:

Stay on top

If this option is ticked, PTFB Pro's main window will stay in front of most other windows while you're working with it. It has no effect while PTFB Pro is minimized to the system tray.

Run at Startup

PTFB can be configured to run automatically when your computer starts up. This item shows the current state (ticked means auto-start is enabled) and allows you to toggle it without having to go into the Configuration screen.

Always Show Tabs

All PTFB Pro's items are held in tabbed groups. By default PTFB Pro hides the tab bar if there is only one tab - this makes more economical use of screen space.

Tick this option if you'd prefer PTFB Pro to show the tab bar at all times, regardless of how many tabs there are. Note that you may need to resize PTFB Pro's main window when the tabs are displayed.

Tabs

A submenu containing commands for creating, renaming, ordering and deleting tabs. The same commands are presented when you right-click on an existing tab.

Configure...

This opens up the PTFB Pro Configuration screen, allowing you to alter various settings including response time, SMTP configuration for notification emails, and logging options.

Set Password...

Access to PTFB Pro can be password-protected, preventing casual attempts to interfere with its operation. This may prove useful if you're using PTFB Pro on a demonstration computer, for example. To start password protection. select this command and enter a short password into the resulting Set Password dialog. To cancel password protection, just enter a blank password in to the Set password dialog.

If you password-protect PTFB Pro then subsequently forget your password, don't panic - there is a simple solution as long as you are comfortable with a little registry editing. See the Troubleshooting guide for more details.

New Macro

This submenu is just an alternative way of creating the two types of macro: window-based and screen-based.

Set Run Hotkey

When an enabled macro is selected in PTFB's list, the Run Macro button becomes available. This allows you to run a macro manually while PTFB's main window is open. The drawback is that to press the button, you've got to bring PTFB's window to the front. If you define a hotkey for the Run facility, you can use it even when PTFB's window is obscured by others.

Clear Run Hotkey

Removes the hotkey defined for the Run Macro button, if any.

Explore Log Folder

If you're using PTFB's notifications to log when an item fires, you can use this to quickly open an Explorer window at the folder that holds the log. The file you're looking for is "PTFBPro.log" - it's a plain, comma-separated text file viewable in Notepad and other text editors. Any associated screenshots will be the same folder.

Import Legacy Targets...

Users of older versions of PTFB can import existing target entries as follows:

  1. Select Import Legacy Targets... from the Options menu
  2. Browse to the PTFB.cfg left over from your old PTFB installation (you'll find it in the same directory that housed the original PTFB.exe file)
  3. If the import is successful, targets from the old .cfg will be added to any existing targets in PTFB Pro's list.

Website...

Opens up the PTFB Pro website in your default browser.

Support Forum...

Opens up your default browser and takes you straight to the PTFB Pro support forum on the TLHouse website

Email Tech Support

Composes a new email in your default email client, pre-addressed to our support address: support@ptfbpro.com

About PTFB Pro

Shows the About screen for PTFB pro. This contains the full product version number, and current trial or registration status.


Organizing Macro and Single-Press Items into Groups

When you first use PTFB Pro, all the macro and single-press items you create are held together in a single group, and the tab bar shown above is not displayed. However, you can create additional groups and split your items between them for easier management. Please read through the topics below for more information.

Forcing the tab bar to display at all times

PTFB Pro shows the tab bar automatically when there is more than one group (tab), but you can make PTFB Pro show the tab bar even when there is only one group. To do so,

  1. Press the Options button
  2. Select "Always Show Tabs" from the resulting menu

Creating a new group

There are several ways to create a new group:

  1. Right-click on the list and choose "New Tab..." from the resulting popup menu, OR
  2. Right click on an existing tab and choose "New Tab..." from the resulting popup menu, OR
  3. Use the keyboard shortcut CTRL +T

Whichever method you use, PTFB will ask you to choose a non-blank name for the new group.

Deleting a group

To delete a group, right-click on the corresponding tab and choose "Delete Tab" from the resulting menu.

Some important points to note about deleting groups:

  • If the group is not empty, PTFB Pro will warn you that deleting the group will also delete the items it contains - heed the warning if you don't want to lose those items!
  • You can't delete the last remaining group - one group must always exist to provide a home for any new items you create

Renaming a group

To rename a group, either:

  1. Right-click on the corresponding tab and choose "Rename Tab..." from the resulting menu, OR
  2. Double-click on the corresponding tab

Remember that you can't have a tab with a blank name!

Switch to another tab

Click on the tab in question, or use the keyboard shortcut CTRL + Tab to cycle through all tabs one at a time.

Re-ordering tabs

To change the tab order, right-click on a tab and choose either "Move Tab Left" or "Move Tab Right" to swap it with its neighbor.

Moving items from one group to another

You can use drag and drop to move one or more items from one group to another. Here's how, step-by-step:

  1. Switch to the tab containing the items you want to move, and select those items. Remember you can select multiple items if you hold down the shift key (for contiguous selection) or ctrl key (for noncontiguous selection) as you click on the list.
  2. Left-click on the items and without releasing the mouse button, drag the mouse over the destination tab and release.

Moving items within a group

This can only be done if you have turned off the "Sort List Automatically" option on the configuration screen (or on the popup menu displayed when you right-click on the list).

To re-order items within a group, just select the items in question and drag them to their new position.

Deleting or toggling all the items in a group

First select all the items in the group, either using the shift-click method or by right-clicking on the list and choosing "Select All" from the resulting menu. Next, either hit the delete button or tap the space bar.


Getting Help

You can get help with PTFB Pro using the following methods:

On-Line Help

    • To use help, choose Help > Help topics , or press F1.
    • Most dialogs also have a Help button; click it to display context-sensitive help.
    • Hold your mouse over a control to display a tool tip with information about that control.

Using Web Based Resources

On the Help menu of PTFB Pro, you can access a number of Website pages dedicated to support issues:

    • PTFB Support Forums
      Visit the PTFB Support Forums to exchange ideas with other PTFB users and to get help from the PTFB development team.
    • Customer Care Center
      Use the PTFB Customer Care Center to submit questions to Technical Support, or give us feedback.
    • E-mail Technical Support
      Send an e-mail message to Technical Support - support@ptfbpro.com


Automating Button Pushing

Automating Button Pushing - Single Press

PTFB Pro can respond to the appearance of a given window by simulating a button press.

The advantage of a "single press" entry (as opposed to a macro) is that PTFB Pro goes to great lengths to locate the button in question. With a little configuration, PTFB Pro can be made to hunt down and press the same button in a number of similar - but not identical - windows.

In addition, there are may be a few windows (such as the Outlook security dialog) that don't respond well to macros - in such cases the single press is the way to go!

The following topics describe the steps involved in setting up single press entry in PTFB Pro.

The Basics

Tweaking the Settings


Automating Button Pushing - The Basics

Creating a Single Press Entry

Here's how to configure PTFB Pro to press a single button each time a particular window appears:

  1. Wait until the offending window next appears
  2. Open up PTFB Pro's main window by clicking on its tray icon

  3. Click on "Single Press". The cursor will now change to hand with an outstretched finger. (If you want to abort the new entry at this point, just click the right mouse button or hit ESC on the keyboard).

  4. Move the cursor over the button you want to be pressed, and click the mouse.

If PTFB Pro sees a standard Microsoft button underneath the cursor, a new target entry will be created and added to the list box. Unfortunately, not all programs use standard buttons. In this case, PTFB Pro will issue the following confirmation screen:

Just answer "Yes", and PTFB pro will go ahead a create the new entry anyway. When PTFB Pro next sees the window, it will simulate a mouse press in the same location relative to the top-left of the window.

Note: if a lot of your applications use non-standard buttons and you grow tired of PTFB Pro's confirmation dialog, just tick "Do not show this again" before you answer with Yes or No. PTFB Pro will remember your response, and won't bother you with the same message again.

Additional Configuration

Now you've created a new single press entry, you may want to tweak some of its settings.

You'll notice that the new entry has been given a name based on the caption of the target window, but you may wish to change this to something more meaningful. The new entry has also been given the current default delay, meaning that PTFB Pro will wait a few seconds between seeing the target window and pressing the target button. You might wish to change this delay.

There's another reason why you might like to edit the new entry's settings. PTFB Pro tries to avoid "false positives" - pressing a button in the wrong window - by ensuring that every detail of the window matches the snapshot it took when the entry was created. Unfortunately some windows change subtly each time they're displayed, so you may need to tell PTFB Pro to be a little less strict when it comes to recognizing this target.

The following topic tells you how to make these changes and more:

Automating Button Pushing - Tweaking the Settings

Putting PTFB Pro to work!

Don't forget that PTFB Pro won't take any action while its main window is open.

To put PTFB Pro to work, click "Start Watching", or press the Close box in the top-right corner. PTFB Pro will minimize to the system tray and keep watch for targets.

When it identifies a target, it will wait the prescribed period (if any) before taking action and signal an imminent press by putting a red border around its icon in the tray.


Automating Button Pushing - Tweaking the Settings

To edit a target's properties:

  • first open up PTFB Pro's main window, then
  • either double-click the target in the list, or select the target and hit "Edit.."

The resulting Target Properties sheet has five tabbed pages - click the links below to view information specific to each page:

General

Identifying the Target

Triggers

Notifications

Snapshot


Single-Press Properties - General Page

This page is divided into three sections:

Title

Here you can see the title of the target window (if available) when the macro was created, and set the title that PTFB should display in the main list.

Action

Press Button vs. Hotkey

By default PTFB Pro uses a simulated mouse click, but it can also press the button using a hotkey (short key combination indicated by an underlined character on the button's text). This feature may prove useful in cases where the simulated mouse click action is ineffective. To use the hotkey technique, just select the "Use hotkey" radio button and verify that the key combination is correct. If you want to change the hotkey combination, just press the "Set..." button and type the required keys.

Force Enabled

For targets that have a recognised button to press (rather than a simulated press at particular coordinates), you can set the "Force Enabled" option. As the name suggests, this forcibly enables a greyed-out button prior to pressing it.

Please take care when using this option. Some programs may not react well if a previously disabled button is suddenly pressed - you may see unexpected behavior, or even a crash!

Restore Active Window

When PTFB Pro is about to act on a target, it forces it in front of the current active window to help ensure that all mouse and key presses go to the correct recipient. If you tick the "Restore Active Window" option, PTFB Pro will attempt to re-activate the previously active window once the press action has completed.

This will most often be used for repeated, periodic operations on a background window. It will have no noticeable effect in cases where the target window has already forced itself to the front of the screen by the time PTFB Pro sees it.

Comments

This field allows you to enter a short note or description for the single-press item. The comment will be shown in the tooltip displayed when you hover the mouse over the item's name on PTFB's main screen.


Item Properties - Identifying the Target Page

PTFB Pro takes a lot of care to ensure that it is acting on the right target window. For safety reasons its default settings require an almost perfect match between a candidate window and its snapshot of the original target. If differences are found, PTFB will declare a mismatch and take no action.

The settings on this page allow you to make PTFB more forgiving of certain differences, or to change the attributes that PTFB uses to declare a match.

The page is divided into two sections. The upper section is concerned with identification of the external attributes of the target window: its title, its type and size, and the program that created it. The lower section looks at the contents of the window - its "controls" to use the official Windows term.

Identifying the Main Window

Title

The window's title is one of the first things PTFB uses to match it to a macro or single-press item. Unfortunately, window titles aren't always constant - it's very common for programs to change their title according to the document they're showing. Take Notepad for example - its title includes the name of the file being edited, or the word "Untitled" if you haven't saved yet. Other programs sometimes add an asterisk (*) to the title to denote unsaved changes.

The "Require this text" option allows PTFB to cope with these variations. If part of the window title is always constant and you think it uniquely identifies the window, just enter it in the edit box.

If that doesn't provide enough flexibility, you can tick the regular expression checkbox and enter a suitable expression.

About Regular Expressions

A regular expression is a notation that describes a pattern for matching pieces of text. For example, the regular expression:

Notepad$

will match any title that ends with the word "Notepad" (much more specific than just requiring the title to contain Notepad).

Regular expressions are very flexible and PTFB can handle the most common forms, but make sure you know the syntax for regular expressions before using them!

A good place to start if you're new to regular expressions can be found (with a little effort) at Microsoft's MSDN site. Browse to http://search.msdn.microsoft.com/ and enter the search text "Introduction to Regular Expressions (JScript)".

For people with more experience, by far the best place to go is: http://www.regexlib.com. This is an excellent site. It has a cheat sheet for the basic syntax, a library of ready-made expressions and best of all, an online test page to help work the bugs out of your own efforts.

Fire only if window belongs to program (off by default)

This option is available if PTFB was able to determine which program created the original target window. As the name suggests, ticking this option means that PTFB will only declare a match if a candidate window appears to have been created by the same program.

Match Window Type (on by default)

Windows have various attributes that can't be seen by the naked eye. For example, every window has a type (or class, to use the official term), and this can often help to uniquely identify a window. Unfortunately, some programs give their windows a different type or class every time they run. To help cope with these cases, you can turn off the requirement for a match on window type.

Match Window Size (off by default)

Normally, PTFB doesn't worry about the size of a candidate window, since most windows can be resized manually. However, you might find it useful to require an exact match on size - if so, this option is for you.

Allow Minimized Window (off by default)

By default, PTFB ignores minimized windows. If you enable this option, PTFB will automatically restore a minimized window in order to press it (or run a macro). The restore action is necessary as many programs aren't ready to accept mouse and keyboard actions when they are minimized.

Identifying Window Contents

Another important tool for telling windows apart is their contents - the "controls" or child items that they contain. PTFB offers three options:

Strict (default)

This option requires an exact match between the contents of the candidate window and the snapshot that PTFB took when the macro or single-press item was created.

It's the safest option, but in practice you'll often find yourself using one of the other options (usually "Simple" - see below).

Why? Well many applications many programs make subtle changes to window contents while they're running. If you create a new item and it works once, but afterwards fails to "see" the target window, the chances are you need to try one of the other options below.

Simple

This is a much more relaxed setting. In the case of a macro, it essentially causes PTFB to ignore the window contents entirely. For a single-press item it causes PTFB to check only the target button, if available.

This setting is required for so many windows that we seriously considered making it the default, instead of "Strict". In the end, the Strict option won out for safety reasons, but you can change this yourself - check out the "Defaults" page of PTFB's Configuration Sheet for more details.

By Prompt

If Strict is too.. strict.. and Simple is too relaxed, this option offers a useful compromise. You can enter a piece of text (or a regular expression - see the comments for Window title above) that must be present somewhere in the target window before a match is declared.

Bear in mind that not all text in a window may be visible to PTFB - some programs prefer to draw text on a window instead of loading it into standard text control. To help with these cases, PTFB fills the editable drop-down list (immediately below the By Prompt option button) with all the text it can see. If you enter text that isn't in the list, it's unlikely that PTFB will be able to match against it.

TIP#1: If you find yourself always having to change the trigger options when you create a new macro, don't forget that you can alter the defaults - check out the "Defaults" page of PTFB's Configuration Sheet for more details.

TIP#2: If PTFB is having trouble recognizing a target window, first look to see if the title is changing from one occurrence to the next. If it is, try the more flexible window title option above. If that doesn't help, try switching from Strict contents checking to Simple. In the vast majority of cases, that will do the trick.


Item Properties - Triggers Page

Originally, PTFB Pro would only trigger a single-press or macro when a matching target window appeared. Following helpful feedback from our users, PTFB now offers a range of flexible triggering options, described below.

Always remember that the "master switch" is still on PTFB's main page. If you disable an item there, it won't trigger under any circumstances - regardless of what trigger options are set on this page.

Trigger When Target Window Appears (on by default)

This is the most commonly used trigger option, and is on by default. The following sub-options are available:

Initial Delay (default 1 sec)

When a target window appears, PTFB will wait for the prescribed period before taking action, and put a red border around its tray icon to indicate that a countdown is in progress.

The default delay is 1 second - this is partly for safety, and partly to let you know whether PTFB recognizes a target or not (helpful while you're still finding your way around PTFB's window identification features). If you want PTFB to handle the target window immediately, just change the delay to 0 secs.

Note that you can specify the delay down to a granularity of tenths of a second. This can be handy in the following cases:

  • You want to force several targets to fire in a particular order. To accomplish this, separate the targets by small increments in the initial delay.
  • The target window isn't always ready for action as soon as it appears, so an initial delay is required, but a whole second is too long!

Limit to Specific Hours (default off, all hours selected)

You can limit the "on appearance" trigger to certain hours of the day. For example, you can set an item to trigger only after your hours of work, or only during lunchtimes etc.

Limit to Specific Days (default off, all days selected)

You can further limit the trigger to specific days if required.

Other Triggers

The following additional trigger options are available.

By Schedule (default off)

PTFB has its own scheduling option, similar Windows' own inbuilt scheduler. This allows the item to be set to trigger at certain time: once a day, on certain days of the week, certain weeks of the month and so on. Note that when a schedule fires it does not guarantee that action will be taken - just that the item will have an opportunity to do its thing. If the item requires a target window to be present, and a suitable target isn't there, then the opportunity will be lost and no action will be taken until the next "slot" comes around.

Note#1: Schedules can only fire when PTFB is enabled and in "watching" mode. If a schedule is set to trigger when the main window is open, it will be ignored.

Note#2: The next trigger time is calculated from the previous trigger time, if available. If you modify the schedule, the record of the previous trigger time will be erased.

By Hotkey (default off)

You can define a hotkey for running an item manually. The hot key will work whether PTFB is in watch mode or sitting open on the screen.

Take care when choosing the key combination - there are certain keys that are normally reserved for common Windows functions. You can claim some of these as a hotkey, but doing so could lead to confusion for you, and for others (if your PC is shared).

Additionally, please be aware that Windows allocates hotkeys on a first come, first served basis. If you've set another program to use a particular hotkey, it'll likely prevent PTFB from using the same hotkey. Currently there is no way of getting Windows to give you an overview of hotkey assignments (more's the pity).

By Command Line (default on)

Each single-press and macro item in PTFB has its own unique four-digit code. If you run PTFB from the command line with up to two of these codes (separated by a single space), PTFB will trigger them almost instantly. The code for each item is shown opposite the "By Command Line" option, along with an example command line. You can select the sample line and copy it to the clipboard if you wish.

It doesn't matter whether PTFB is already running or not. If you get the command line right, and PTFB's window is not currently open (or disabled) then the appropriate item(s) will be given an opportunity to run. Of course, if the required target window is not present, then nothing will happen!

So, how could you use this?

Well, if you don't like PTFB's inbuilt scheduling options, why not use your own preferred scheduling program? Just give it the command line shown here, set the required schedule, and you're done. That's just one example. Developers and administrators can use the command line to tie PTFB in to their various scripts and processes, ensuring that the actions only occur when they're needed.

Note#1: If PTFB is already running when the command line is issued, it must be in the watching state (main window not showing) or the command will be ignored.

Note#2: If PTFB is not running when the command is issued, it will trigger the required item but keep running afterwards. If you want PTFB to only run an item in response to the command line, just untick all the trigger options except By Command Line.

By Macro Run Command (default on)

This is only available for macro items.

When editing a macro, you can insert a special command to run another macro. This will only have an effect if the "By Macro" option is enabled - so unticking this is a quick way to disable a nested run command without having to re-edit the macro.

Note: When one macro is run within another, its notifications (if any) do not run. Only the notifications associated with the outer macro can fire.

Repeat Options

By default, PTFB will act only once on each target. If you tick the Repeat box, you allow PTFB to act repeatedly on the same target regardless of how it was triggered.

  • You can set a delay between each repeat - for safety reasons, this defaults to 1 sec. Like the initial delay, you can fine-tune the repeat delay to within tenths of a second.
  • You can set the repeat cycle to continue indefinitely, to stop after a certain time, or to stop after a certain number of repetitions.

CAUTION: Think carefully before enabling repeat with a zero second delay, especially with single-press items! If PTFB is busy pressing a button 50 times a second, you won't get much chance to regain control of the mouse!

If you're going to do this, please setup a hotkey to disable PTFB or open its Window first. You can do this via the General page of the configuration screen.

Otherwise, your only recourse may be to hit CTRL-ALT_DELETE and use task manager to open another copy of PTFB. This causes PTFB to open its main window and halt its activities.

TIP#1: If you find yourself always having to change the trigger options when you create a new macro, don't forget that you can alter the defaults - check out the "Defaults" page of PTFB's Configuration Sheet for more details.

TIP#2: "Trigger When Target Window Appears" is still available for screen-based macros, but since there is no target window as such, the macro will always want to fire as soon as you click the "Start Watching" button. It's more common to disable this trigger option for this type of macro, and use one of the other triggers instead (typically the hotkey trigger).

TIP#3: The repeat options apply to all triggers. If you want the repeat options to be different depending on the trigger type, you'll have to create a copy of the single-press or macro and adjust its triggers and repeat options appropriately. There's a quick way to create a copy of an existing item - just right-click it in the main list and choose "Duplicate" from the resulting menu.


Item Properties - Notification Page

Sometimes it's useful to have a record of windows that PTFB Pro has handled. For example, if you're getting annoying error reports from a program, you can have PTFB Pro dismiss them quickly, but still record the error text each time. That way you can get on with your work, but still have enough information to troubleshoot the problem later on.

When PTFB Pro handles a target window, you can have it take any/all of the following actions:

  • Email you with a screenshot and details collected from the target window
  • Write equivalent information to a text log
  • Run a script or program of your choosing

Send Email

If you have access to an outgoing SMTP server (whether it's on your network, or available through your persistent internet connection) you have PTFB Pro send you an email each time the target is handled.

You can set the subject line for the email, include prompt text collected from the target window, and attach a screenshot of the target window.

The format of the screenshot (if any) is set for all targets via the PTFB Pro Configuration property sheet, as are the details of the outgoing email server. If you tick "Send Email" but haven't yet entered your SMTP server details, you'll be prompted to do so now. Bear in mind that disabling email notifications in the PTFB Pro Configuration property sheet will prevent any emails going out, regardless of individual target settings.

Write To Log

PTFB Pro creates a folder on you computer for storing its text log and screenshots. The location of this folder is set in the PTFB Pro Configuration property sheet. If you select "Write To Log" an entry will be made in the text log each time PTFB Pro handles the target window. Optionally, you can have PTFB Pro take a screenshot (referencing it in the log entry) and include the target's prompt text in the log entry.

As with emails, no logging will occur for any targets if the "Enable Logging" option is turned off in the PTFB Pro Configuration sheet.

Run Script or Program

If you give PTFB Pro a command (similar to a command you might enter into the Windows "Run" box, or in a Command Prompt window), it will run it shortly after the target fires.

To help you compose the command, you can drag files into the "Cmd Line" edit box, or use the Browse facility. Click the "Test Now" button to check that you've got the command right.

Note: When you drag files into the "Cmd Line" edit box they will be appended to the current contents.


Item Properties - Snapshot Page

This page shows all the target window controls that PTFB Pro would look for when using the "strict" method of checking window contents. It may help you to get the right settings when you're making changes in the "Identifying the Target" page

If your macro/single-press item was created using PTFB Pro version 3.0 or better, you'll also have the option of viewing a screenshot of the original target window.


Recording and Playback of Macros

When you need to do more than just automate the pushing of a single button, you can use a macro. Macros can carry out a complex sequence of keyboard and mouse actions, and you can choose whether to run them: manually, automatically when a target window appears, according to a schedule, or at the request of other programs on your computer.

This enables PTFB Pro to do far more than simply dismiss an irritating confirmation screen. For example, it can automatically handle logins for various programs and network/internet connections, help you with repetitive editing tasks, or quickly reapply those configuration changes that your favorite application sadly keeps forgetting.

The drawback of a macro is that it is usually very specific to one window. If anything changes about the window in question, such as its size, or contents, the macro may not do exactly what you'd hoped. It is nevertheless a powerful tool for reducing irritations and interruptions while you're working in Windows.

The following topics describe the steps involved in setting up a macro in PTFB Pro.

The Basics

Tweaking the Settings

One more thing: both play back and recording can typically be stopped by tapping the Pause/Break key (on most keyboards, this is grouped together with Scroll Lock and Print Screen). If for any reason PTFB Pro doesn't respond to this, try holding down CTRL and tapping the Escape (Esc) key.


Macros - The Basics

Creating a new macro

Here's how to record a standard macro using PTFB Pro:

  1. Open up PTFB Pro's main window by clicking on its tray icon

  2. Click on "Macro". The cursor will now change to an open hand. (If you want to abort at this point, just click the right-mouse button or press Esc on the keyboard)

  3. Nominate the target window by clicking just inside it. As you're moving the mouse to do this, you'll see a highlighted border to show you which window PTFB Pro will pick when you click.
  4. A Recording dialog will appear, signaling the PTFB Pro is now recording your interactions with the target window.
  5. Carry out the sequence of actions you want PTFB Pro to repeat. If you make a mistake, can start again by hitting Restart. If you want to abort creating the macro completely, click the Close box on the Recording dialog.
  6. When you've finished, end the recording by pressing Stop on the Recording dialog or by hitting Pause/Break on the keyboard.

Screen Macros

You've seen how to create a macro that operates on a specific window, but PTFB Pro also has a "window-less" or screen macro.

Why

You're probably wondering what the differences are between the two types of macro, and why you might choose one over the other.

As already mentioned, the standard window-based macro is designed to operate on exactly one window. It stores mouse positions relative to the top/left corner of the window, so the macro will still perform correctly if the window changes position from one appearance to the next.

On the other hand a screen macro has no tolerance for windows that change position. It can however operate anywhere on the screen, even the desktop and taskbar. Also, since it doesn't need a target window to be present before it will run, you don't spend any time tweaking the target identification settings. It's often a good choice if you're working through a repetitive editing task in a maximized program window. Maybe you want to quickly record a one-off macro to help get the task done quickly? Just create a screen macro to edit one line and move to the next, then play it back repeatedly (maybe using the Run Macro hotkey?) until the job is done.

How

To create a screen macro, click on the right side of the Macro button and choose "New Screen Macro" from the resulting menu. Alternatively, hit the Options button and navigate to the "New Macro" sub-menu.

When you create a screen macro, you skip step (3) in the list above - you don't nominate a target window. Instead, you go straight to the recording stage.

NOTE: You may want to change the default name assigned to the new macro.

Additional Configuration

Now you've created a new macro, you may want to tweak some of its settings.

You'll notice that the new macro has been given a name based on the caption of the target window, but you may wish to change this to something more meaningful. The new entry has also been given the current default delay, meaning that PTFB Pro will wait a moment between seeing the target window and pressing the target button. You might wish to change this delay, or set the macro to repeat automatically.

Alternatively, you might like to change the triggers that cause the macro to run. Maybe you only want it to run at certain times of certain days of the week, or maybe you'd like to define hotkey to run the macro on demand.

And there's another reason why you might like to edit the new entry's settings. PTFB Pro works hard to avoid "false positives" - pressing a button in the wrong window - by ensuring that every detail of the window matches the snapshot it took when the entry was created. Unfortunately some windows change subtly each time they're displayed, so you may need to tell PTFB Pro to be a little less strict when it comes to recognizing this target. Take care however - macros are often closely tied to the original target window; if you make them fire for different windows, you not get the result you were wanting.

The following topic tells you how to make these changes and more:

Macros - Tweaking the Settings

Putting PTFB Pro to work!

Don't forget that PTFB Pro won't let a macro run automatically while its main window is open.

To put PTFB Pro to work, click "Start Watching", or press the Close box in the top-right corner. PTFB Pro will minimize to the system tray and keep watch for targets!

One more thing: both play back and recording can typically be stopped by tapping the Pause/Break key (on most keyboards, this is grouped together with Scroll Lock and Print Screen). If for any reason PTFB Pro doesn't respond to this, try holding down CTRL and tapping the Escape (Esc) key.


Tips for Macros

The following tips will help you to get the most out of PTFB Pro's macros.

The Importance of Playback Speed

By default, each new macro is set to playback at maximum speed, eliminating all unnecessary mouse movement. This will be the most suitable setting in many cases, but sometimes the target window may not be able to keep up with this rapid-fire delivery of commands. When this happens, the macro may appear to "skip" a few steps, and you may hear beeps as the window signals that it is not ready to receive more commands.

This is most likely to happen if your computer is a little slow and/or the application you're running is bulky or complex. One solution to this is to tweak the playback settings for your macro - try reducing the speed, try disabling the "Eliminate redundant mouse movement", or if necessary try both. The Macro Editing tab is particularly handy for this kind of experimentation - you can reduce the speed and immediately see the results by hitting the Test Now button.

If you don't like the idea of reducing playback speed, there may be an alternative. Try deleting then recreating the macro but this time use the keyboard during recording rather than the mouse. It's sometimes the case that even though a window isn't ready to respond to mouse commands, it will respond to keys (the so-called "type ahead facility"). See the next section for other reasons why keyboard control sometimes wins out over the mouse...

One other thing to consider. If the target application (or Windows) is using brief animation sequences such as menu fade-in, turning this animation off may improve matters.

Keyboard control is sometimes preferable to using the mouse

When PTFB Pro records a macro, mouse positions are stored relative to the original target window. Consequently playback of mouse actions may fail if objects within the window move around from one session to the next, or if the window is resized.

For example, Windows automatically repositions popup menus to avoid running off the edge of the screen. If you define a macro that selects from such a menu using the mouse, it could fail if Windows decides to make the menu appear at a different location.

Fortunately, most programs can be controlled by the keyboard as well as the mouse, and keyboard commands are NOT position dependent. If you bring up a menu with the mouse, but select from it using the arrow keys and the Return key, your macro will be more robust.

Note that Windows XP sometimes hides the shortcut keys that can be used to control a window. Hitting the ALT key brings the shortcut keys back!

Beware commands that rely on previous operations (e.g. copy to clipboard)

Let's say you have copied some text to the clipboard, and you now define a macro that pastes that text into a window. Your macro will only behave as expected so long as that same text is in the clipboard!

This may seem obvious now, but it's surprising how may people get caught out when they're engrossed in a task.

Use the Pause/Break key to end a recording

PTFB Pro's recording dialog contains a "Stop" button. This works perfectly well, but the recording may contain the movement of the mouse towards the Stop button. This usually isn't a problem (especially if "Eliminate redundant mouse movement" is enabled), but hitting the Break key will stop the recording instantly, without any superfluous mouse movement.

Use CTRL + ESC or Pause/Break to abort macro playback

Windows locks out normal keyboard and mouse movement while a macro is playing back. This isn't an issue if you go with PTFB Pro's default settings - even long macros play back in the blink of an eye. But if you set playback at normal speed, you might want to interrupt it to regain control of your computer.

There are two ways to do this:

  1. Tap the Pause/Break key. On a typical desktop keyboard this sit alongside Scroll Lock and Print Screen.
  2. Hold down the CTRL key and tap the ESC key. Incidentally, these are the same keys that open up the Start menu, so may see that pop open at the same time. Just hit ESC again to dismiss it.


Macros - Tweaking the Settings

To edit a target's properties:

  • first open up PTFB Pro's main window, then
  • either double-click the target in the list, or select the target and hit "Edit.."

The resulting properties sheet has six tabbed pages (or four if it's a screen macro) - click the links below to view information specific to each page:

General

Identifying the Target

Triggers

Editing

Notifications

Snapshot


Macro Properties - General Page

This page is divided into four sections:

Title

Here you can see the title of the target window (if available) when the macro was created, and set the title that PTFB should display in the main list.

Playback

You can adjust the playback speed for the macro on this page, or on the macro editing page (if present - see below). The speed range runs from one quarter of normal speed, right up to the maximum possible speed on your computer. The mid-point in speed range represents 1x speed - at this setting, the macro should play at about the same speed as the original recording (subject to system load).

This section also contains an option labeled: "skip redundant mouse movement". When set, PTFB deliberately skips over what it considers to be unnecessary mouse-move actions during playback, increasing the playback speed still further.

If you want to know which mouse moves PTFB thinks are redundant, try setting the macro to a slow speed and tick the "skip redundant" box. You'll see that PTFB only takes note of mouse moves that occur immediately before a mouse button action - all the ones in between that describe the path the cursor took are skipped. This is fine for many applications - but not so good of you're recording the movement of the pen tool in a free-hand drawing package!

TIP#1: If you find that a macro is playing back but not producing the results you expect, it's often a good idea to try reducing the playback speed - sometimes mouse and key actions can arrive before the target program is ready for them. Also try turning OFF the "skip redundant" setting - again, some programs don't cope too well if they don't see a more natural movement of the mouse cursor.

TIP#2: If you find yourself always having to change the playback speed or the "skip redundant" setting when you create a new macro, don't forget that you can alter the defaults - check out the "Defaults" page of PTFB's Configuration Sheet for more details.

Restore Active Window

When PTFB Pro is about to act on a target, it forces it in front of the current active window to help ensure that all mouse and key presses go to the correct recipient. If you tick the "Restore Active Window" option, PTFB Pro will attempt to re-activate the previously active window once the macro has completed.

This will most often be used for repeated, periodic operations on a background window. It will have no noticeable effect in cases where the target window has already forced itself to the front of the screen by the time PTFB Pro sees it.

Hide Macro Editing Tab

There may be times when you don't want others to be able to view or change the contents of a macro. One to accomplish that is to use this setting. When you tick the box, you'll be asked to provide an unlock password. Choose a password you won't forget (more on that later) then click OK on the sheet to save your changes. The next time you view the properties for you macro, the editing tab simply won't be there.

To get the editing tab back, untick the "Hide" box and supply the correct password, then again click OK on the sheet to save changes. The editing tab will again be present when you next view the macro's properties.

CAUTION:

  1. Don't forget your unlock password - if you do, you won't be able to edit your macro! You'll have to delete it and create a new one from scratch.
  2. Please be aware that this function does NOT provide bullet-proof security. Where possible, PTFB uses Windows' own cryptographic services to encrypt the macro itself and your unlock password when storing them on disk, and PTFB itself contains a degree of protection against memory-dumping and similar attacks. However, suitably skilled individuals would probably be able to break these protections. You should always weigh the risks before recording a macro that enters a critical password, for example!

Comments

This field allows you to enter a short note or description for the macro. The comment will be shown in the tooltip displayed when you hover the mouse over the item's name on PTFB's main screen.


Item Properties - Editing Page

Item Properties - Macro Editing Page

This page allows you to modify a macro you've previously recorded.

The page contains two lists: the one on the left shows new actions that you can add to the macro, while the central list shows the current contents of the macro. The central list allows multiple selection, so you can copy/paste/delete or drag-drop multiple items at once.

Adding a New Action

To add a new action to the macro, either double-click the required action in the left-hand list, or select one of the actions and press the "Add..." button on the right. The new action will be added immediately before the currently selected item in the central list. If no item is selected, the new action will be added at the end of the list.

A run-down of the available actions is provided below, but first here are some general points about mouse and keyboard actions.

  1. All the mouse actions, and some of the keyboard actions have an optional time delay value (see Additional Notes below).
  2. The mouse actions require you to specify a pair of coordinates - please make sure you use the correct coordinate system. Read the section titled "Specifying Mouse Coordinates" below for more details!
  3. As you add items, the selection moves forward. This makes it easier to add a series of actions without having to adjust the selection repeatedly.

OK, now lets look at the available actions.

Move Mouse

This just repositions the mouse.

Left Mouse Click

This actually adds two items to the list - a left mouse down (the left mouse button being pressed), followed by a left mouse up (the mouse button being released).

Middle Mouse Click

This actually adds two items to the list - a middle mouse down (the middle mouse button being pressed), followed by a middle mouse up (the mouse button being released).

Right Mouse Click

Same as the other two mouse clicks, but this time for the right mouse button.

Key (Single Direction)

Use this to add a single key up or key down action. First choose the direction, then hit "Set..." to choose the key.

Key Press

This action adds two items to the list - a key down followed by a key up.

Type Text

This option makes it easier to add a series of key actions. It presents a dialog that records what you type until you press the OK or Cancel button. Note that you MUST use the mouse to press OK or Cancel - the Enter and Escape keys will just record key actions.

Force Caps Lock

If your macro enters text, you may find that your keyboard's Caps Lock key occasionally causes the text to come out in the wrong case. This is most often a problem for macros that enter passwords and other case-sentitive text.

If you wish, you can force the Caps Lock key to be on or off for the duration of your macro by inserting a "Force Caps Lock" item. Just add it to the list prior to any other keyboard items.

Run Macro

This inserts a special action that runs one of the other macros you've already defined. You won't be able to pick the macro you're currently editing, as this would set up a never-ending loop.

Run Executable

This inserts an action that runs a command line of your choosing. Much like the Windows "Run.." box, you can enter the command by browsing, by typing, and by dropping files onto the edit box.

Take care to quote paths that include spaces - e.g. use "c:\program files\mybatfile.bat". If in any doubt, use the "Run Now" button to test the command line in the edit box! If it doesn't work, the resulting error message should help you fix your command line.

Repeat... Loop

If you want to carry out a series of actions more than once, you could copy and paste them into the list several times. A more efficient way however would be to wrap a Repeat Loop around them.

When you add a Repeat Loop, you're first asked how many times you want the loop to repeat. To save any confusion, the number you supply is the total number of times the actions inside the loop will be run.

Add a Repeat Loop actually places two new items in the list: A "start" item and an "end item". Initially, these two items are placed next to one another - it's up to you to drag/drop (or copy/delete/paste) items until the start and end items enclose the actions you want to repeat.

Forced Delay

Many of the actions already have a delay that you can edit, but this delay is reduced or increased on the fly according to the playback speed you've chosen. The "Forced Delay" action inserts an absolute delay that is not affected by the playback speed.

Switch To Prog

Use this action to switch to another program that is already running on your computer. PTFB Pro finds the main window for the program, restores it if it is hidden or minimized, and brings it to the front of the display.

The action takes the name of the program's executable file, including the extension. For example, Outlook's executable file is "Outlook.exe".

To help you get the right name, the drop-down list in the Add/Edit box contains the names of the executables behind all the currently visible top level windows. If your target app isn't listed, it might not be running, or it might be hidden or minimized to the tray. In that case, cancel out of the Add/Edit box, get the target program's main window visible on the screen and try again. Alternatively, if you're an experienced Windows user, you might find the exectuable name listed in the "Processes" tab of Windows Task Manager (on XP, use CTRL+ALT+DEL to summon Task Manager).

Note: Remember that when you switch to another program, the coordinates for any subsequent mouse activity might not be correct. Depending on your goals, you might find it better to create a second macro for the other program, and use the Run Macro action to launch it from within your main macro.

Comment

You can place comments at any point within the macro to help remind you what a particular group of actions does. The comments are completely ignored during playback.

Modifying an Existing Action

To modify an existing action, select it in the central list and press one of the buttons on the right-hand side of the page. Alternatively, if you want to edit an item, you can just double-click it.

To move an item's position within the list, you can either use drag-and-drop with the mouse, or copy/delete/paste.

To create a duplicate of an item either use copy/paste, or hold the CTRL key down while dragging/dropping with the mouse.

Quick Access to Editing Operations

If you right-click in the macro contents list, a popup menu will appear. This contains all the principal editing operations, plus others that may be of use in certain circumstances such as:

Select Redundant Mouse Moves - this selects the items that PTFB Pro will skip if the playback option "Skip redundant mouse movement" is set.

Testing the Macro

It's always a good idea to test your macro after making changes. Once you hit the OK button on the sheet, your changes are saved and there's no way of undoing them (other than by manually re-editing). That's why the page has the "Test Now!" button. Clicking this temporarily hides PTFB and runs your macro there and then, regardless of the triggering options you've set. Also note that macro test runs will not cause any notifications to fire.

It's often easier to see what the macro is doing if you reduce its playback speed. For convenience there's the familiar speed control on this page as well as on the General page. Note that these two pages share the the speed setting - change it on one and you've changed it on both.

Additional Notes

Here are a few notes about the meaning of particular item values:

About the Time Delay Value

All the mouse actions, and some of the keyboard actions have an optional delay value. This value is the time in milliseconds that the system should wait before carrying out the action when playing back at 1x speed. When playing back at a different speed, the value is multiplied by an appropriate factor to increase it (for slower playback) or decrease it (for faster playback).

Specifying Mouse Coordinates

Window-relative versus Absolute (screen) coordinates

Most macros are recorded for a target window, rather than for the screen as a whole. Mouse actions recorded in this way store their coordinates relative to the target window - in other words that coordinates are really an offset from the top/left corner of the target window. This allows PTFB to always hit the correct spot within the window, even if it appears a different position on your monitor each time.

By contrast, absolute coordinates are always an offset from the top/left corner of your monitor, in other words they do not allow for any movement of items between one run and the next.

As a general rule, if you are editing a macro with a target window, you should use window-relative coordinates. If your macro is for the whole screen, then you should use absolute coordinates.

Setting the Coordinates

You can either type the coordinates directly into the X and Y boxes, or use the "Set Using Mouse" button.

Hitting this button lets you locate an exact point on the screen using the mouse. However, there is a complication! If you're using window-relative coordinates, you'll first be asked to indicate which window to use to record the coordinates. In almost all cases, you should choose the target window - otherwise you'll find that during playback the mouse does not end up where you planned!

TIP: This page's test facility is handy if a particular program is having trouble when the macro plays at full speed. You can incrementally lower the speed and test until you find a good compromise between speed of execution and reliability.


Program Monitor (ProgMon) Macros

PTFB Pro versions 3.4 and above allow to create "program monitor" or "progmon" items. These periodically check to see if a particular program is currently running on your system. Depending on how you've set them up, they'll either launch the target program if it isn't running, or close/kill the program if it is running.

Why would you need this? Well here are a few uses:

  • An office computer has utility that should be kept running throughout the day, and sometimes colleagues accidentally quit the utility
  • There's a program you'd like to keep running, but sometimes it crashes out without any warning or error
  • There's software on your PC that checks for updates (e.g. for the Java runtime). It's OK for them to run when the computer first starts up, but you don't want them running all day because they just consume memory and other resources for no good reason. Stopping them by hand is a pain!

If you'd like to create a program monitor item, the first step is to click the right-hand side of the Macro button on PTFB's screen and choose "New ProgMon Macro", OR choose Options -> New Macro -> New ProgMon Macro. This launches a wizard to help you create the new item.

New Program Monitor Wizard

To read more about the Wizard, please click the links below:

New Program Monitor - Choose Program

New Program Monitor - Choose Action

New Program Monitor - Launch

New Program Monitor - Close

Other things to be aware of...

  1. The default item created by the wizard is set to repeat about once every second. If this isn't what you need, you can edit the new item once the wizard has closed, switch to the Triggers page and set up your own trigger conditions, just as you would for any normal macro or single press item. You could even set the item to trigger on a hotkey - thus tieing the launch (or death) of your target program to a handy key sequence.
  2. If you're aiming to keep an unstable program running, you may find that some of the time the program exits without any warning, while at other times you see the familiar Windows error report "XXX has encountered a problem and needs to close" or similar. If the program simply exits without an error, then PTFB Pro will have no problem re-launching it. However in the case where an error dialog appears, the program actually hangs around until that dialog has been dismissed. Consequently, PTFB Pro will think that the program is still running and won't re-launch it until the dialog has been dismissed. The solution is simple: create an additional single press item to dismiss the error dialog whenever it appears.
  3. ProgMon Macros are not available on Windows 98 or ME - you must be running NT4 or better to use ProgMon macros.


New Program Monitor - Choose Program

This page lets you tell PTFB Pro which program you want to monitor. It displays a list of all the programs, or to be more accurate, "processes", that are currently running on your PC.

If you see your target program in the list, just select it and hit Next.

If the target program is not in the list, you can still enter it manually in the boxes below the list. The most important field is the process name. This should contain the name of the program/process as it would be displayed in Windows Task Manager. For example, PTFB Pro's process name is PTFBPro.exe (note there's no space). The description field is optional, and is really there just to remind you which program you've picked.

When you've chosen the target program, hit the Next button to move to the next page of the wizard.

NOTE: Under Windows XP, you'll typically see a lot of processes listed - in fact if you've never looked at the Processes tab in Windows Task Manager you may be shocked at just how processes are currently running. Don't be alarmed by this - it's normal - and in particular please don't be tempted to use PTFB Pro to forcibly quit any and all process you don't recognize! Many of those processes will be vital to Windows operation, and if you quit them, your PC may become unstable and require a reboot. Only target programs that you're familiar with!

Program Monitor Macros - Overview


New Program Monitor - Choose Action

Here, you choose whether you want to launch a program if it's not running, or forcibly stop a program if it is running.

Make your choice and hit the Next button.

Program Monitor Macros - Overview


New Program Monitor - Launch

Having chosen to have PTFB Pro launch a program whenever it's found not to be running, you now have to tell PTFB Pro how to launch it.

For most programs, it's just a matter of entering the full path to the program's main executable file.

However, in some cases the "program" in question might run as a service, in which case you might use a "net start XXX" command line. Or maybe you want to run a batch (.bat) file, or a vbs script etc. In these cases, enter your command line and tick the "Use cmd console" box. This will cause the command to execute as though you'd entered it into a command console (aka DOS box for those who remember the bad old days...)

One other option for those running under Windows 2000 or better is to cause the command line to execute as though it was issued from a different account. If you want to use this option, just fill in the account name and if appropriate, the corresponding password. The password should be entered twice for confirmation. Note that very few people will need to use the target account option - if in doubt, just leave those three fields blank and your command will run normally.

Test to avoid disappointment!

After you've entered your command details, hit the Test Now button. If anything goes wrong, PTFB Pro will try to give you an error message that will help you fix your command. Common problems include:

  • Not enclosing a path in quotes when it contains spaces. For example, if the program resides in the Program Files folder, the command line should look something like this: "C:\Program Files\ProgXXX\ProgXXX.exe" /param1 /param2
  • Not having Use cmd console ticked when it is needed
  • Having Use cmd console ticked when it isn't needed!

Program Monitor Macros - Overview


New Program Monitor - Close

Having chosen to have PTFB Pro terminate a program when it is found to be running, you now need to tell PTFB Pro just how to carry out the close operation.

There are three options:

Request Quit

As the name suggests, this is the most polite method. It sends a message to the program's main window, telling it to close down. It's the preferred method, but not all programs will play fair, and a heavier handed approach may be required.

Forced Exit

This is the most heavy handed method. PTFB Pro dons its "Terminator" shades and bikers jacket and goes about its business with ruthless efficiency. Assuming the termination succeeds, the unfortunate program gets no chance to close down cleanly. Under certain circumstances this can make Windows unstable, and/or lose data entered in that session. Use with care, and please do not shutdown any processes that Windows depends on!

Use Cmd Line

If you wish, you can provide your own command line which will be used to terminate the target program. For example, you could use the extra functionality in a tool such as PSKILL to close the program in a specific way, or in the case of a service, you could request a controlled shutdown using the "net stop XXXX" command.

The command line you provide may contain the special parameter {{ProcID}}. When PTFB Pro executes the command line, it automatically substitutes the process ID of the target program in place of the {{ProcID}} variable. Note that this variable is case sensitive - must have a capitalized 'P' and 'ID'.

You can also instruct PTFB Pro to execute the command line as though you'd entered it into a command console (formerly known as a DOS box). To do this, just tick the "Run from command console" checkbox.

Program Monitor Macros - Overview


ProgMon Item Properties - General Page

This page is divided into three sections:

Title

Here you can set the title that PTFB should display in the main list.

Target Program

The most important field in this section is the process (image) name. This tells PTFB Pro what name to look for in the list of currently running processes that Windows maintains. Case doesn't matter, but it's important that you use the full name that you'd see in the Process tab of Task Manager when the program is running. For example when PTFB Pro is running, its process name is PTFBPro.exe, which also happens to be the full name of PTFB Pro's main executable file.

This section also contains a description field. This isn't used by PTFB Pro internally, it's mainly there to help you remember which program this item applies to.

Comments

This field allows you to enter a short note or description for the single-press item. The comment will be shown in the tooltip displayed when you hover the mouse over the item's name on PTFB's main screen.

Program Monitor Macros - Overview


ProgMon Item Properties - Launch Page

This page is only present if your item is set up to launch a target program that doesn't seem to be running. The page lets you control exactly how the launch is to be carried out.

Command Line & Run from command console

For most programs, it's just a matter of entering the full path to the program's main executable file.

However, in some cases the "program" in question might run as a service, in which case you might use a "net start XXX" command line. Or maybe you want to run a batch (.bat) file, or a vbs script etc. In these cases, enter your command line and tick the "Use cmd console" box. This will cause the command to execute as though you'd entered it into a command console (aka DOS box for those who remember the bad old days...)

Run As (Optional, Windows 2000 and above)

One other option for those running under Windows 2000 or better is to cause the command line to execute as though it was issued from a different account. If you want to use this option, just fill in the account name and if appropriate, the corresponding password. The password should be entered twice for confirmation. Note that very few people will need to use the target account option - if in doubt, just leave those three fields blank and your command will run normally.

Test to avoid disappointment!

After you've entered your command details, hit the Test Now button. If anything goes wrong, PTFB Pro will try to give you an error message that will help you fix your command. Common problems include:

  • Not enclosing a path in quotes when it contains spaces. For example, if the program resides in the Program Files folder, the command line should look something like this: "C:\Program Files\ProgXXX\ProgXXX.exe" /param1 /param2
  • Not having Use cmd console ticked when it is needed
  • Having Use cmd console ticked when it isn't needed!

Program Monitor Macros - Overview


ProgMon Item Properties - Launch Page

ProgMon Item Properties - Close Page

This page is only present if your item is set up to close a target program that shouldn't be running. The page lets you control exactly how the closure is to be carried out.

There are three options:

Request Quit

As the name suggests, this is the most polite method. It sends a message to the program's main window, telling it to close down. It's the preferred method, but not all programs will play fair, and a heavier handed approach may be required.

Forced Exit

This is the most heavy handed method. PTFB Pro dons its "Terminator" shades and biker's jacket and goes about its business with ruthless efficiency. Assuming the termination succeeds, the unfortunate program gets no chance to close down cleanly. Under certain circumstances this can make Windows unstable, and/or lose data entered in that session. Use with care, and please do not shutdown any processes that Windows depends on!

Use Cmd Line

If you wish, you can provide your own command line which will be used to terminate the target program. For example, you could use the extra functionality in a tool such as PSKILL to close the program in a specific way, or in the case of a service, you could request a controlled shutdown using the "net stop XXXX" command.

The command line you provide may contain the special parameter {{ProcID}}. When PTFB Pro executes the command line, it automatically substitutes the process ID of the target program in place of the {{ProcID}} variable. Note that this variable is case sensitive - must have a capitalized 'P' and 'ID'.

You can also instruct PTFB Pro to execute the command line as though you'd entered it into a command console (formerly known as a DOS box). To do this, just tick the "Run from command console" checkbox.

Program Monitor Macros - Overview


Setting up Notifications

When PTFB Pro handles a target window, you can have it take any/all of the following actions:

  • Email you with a screenshot and details collected from the target window
  • Write equivalent information to a text log
  • Take a screenshot of the target window
  • Run a script or program of your choosing

To set up one of the above actions for a target, edit the target's properties by double-clicking on it in the list in PTFB Pro's main window, then switch to the Notifications page.

Note that there are some settings that apply across all notification actions defined on all targets, such as screenshot format (jpg/png) and outgoing email server. These settings can be changed through the PTFB Pro Configuration property sheet (accessed via the Options menu off PTFB pro's main screen).


Getting Help

PTFB Pro Configuration

PTFB Pro has a number of program-wide options that you can change. To do this, first open up PTFB Pro's main window by clicking on its icon in the system tray. Next, click the button marked "Options" and select "Configure..." from the resulting popup menu. You should now see the "PTFB Pro Configuration" dialog.

This has four tabbed pages. For details on the settings available on each page, click on the appropriate link below:

Configuration - General

Configuration - Defaults

Configuration - Email

Configuration - Logging

Configuraton - Don't Show This Again


Configuration - General

Options->Configure: General

This page has three sections, as shown below:

Response

PTFB Pro is not constantly active - it operates on a cycle. At the start of the cycle, it searches for targets and takes appropriate action (pressing buttons and executing macros). The rest of the cycle is spent "sleeping", in order to minimize the effect on your computer's performance.

This affects how quickly PTFB Pro can detect and respond to targets with a zero-second delay. For example, if the target appears while PTFB Pro is asleep, nothing will happen until the start of the next cycle. The default cycle length is about half a second, so some zero-delay targets may not be handled instantly.

You can change this via the Response setting on the General page. Note that a higher response speed comes at the cost of slightly higher processor usage. On most recent computers, even the fastest setting makes no appreciable difference to system performance, but it may be more of an issue if your computer is working flat out on a time-critical task.

Miscellaneous

This section presents assorted settings that change PTFB Pro's behavior.

Run at Startup

Tick this if you want your computer to launch PTFB Pro automatically when it starts up. If you disable it, you'll be responsible for starting PTFB Pro manually via the Start menu.

Show Tooltips

This option causes informative tooltips to be shown when you hover the mouse over PTFB Pro's main window. You can disable it if you find the tooltips distracting.

Defeat Screensaver

A running screensaver can interfere with PTFB Pro's activities. If you select this option, PTFB Pro will attempt to temporarily cancel the screensaver just before simulating a button press or executing a macro. There are two things to note about this option:

  • It won't work if your screensaver locks your computer (i.e. if it requires you to login to regain access)
  • On NT4, PTFB Pro can't accurately determine whether a screensaver is currently running or not. If you're running on NT4 and select this option, PTFB Pro will assume the worst and always take action to exit a running screensaver, which may make it slower to respond to zero-delay targets.

Defeat Icon Hiding

Windows XP has a feature called "icon hiding", which is on by default. It periodically hides system tray icons if they have not been updated recently, and may decide to hide PTFB Pro's icon. This can be confusing if you're not expecting it!

XP's icon hiding can be disabled for certain icons (or indeed for all icons) via "Taskbar and Start Menu" in the control panel. However, if you don't want to go hunting through the control panel you can just tick this option. PTFB Pro will make a point of periodically updating its icon, hopefully convincing Windows XP to leave it alone.

Sort List Automatically

By default, the target list is automatically sorted to maintain alphabetical order. If you disable this behavior, you will be able to order list items manually using drag and drop. There are a few advantages to be had from this:

  • If you frequently enable/disable certain targets, you can have them near the top of the list for easy access
  • The order of entries in the list determines the order in which PTFB Pro detects and processes targets. By carefully re-arranging the list, you can influence the "firing" order for your targets.

Hide When Choosing Target

PTFB Pro automatically hides its main window when recording a macro. If you tick this option it will also hide the main window when you're nominating the target - the first stage in the creation of a single-press item or window-based macro.

Wait at Main Screen / Edit New Item / Start Watching

This setting tells PTFB Pro what you want it do immediately after you've created a new macro or single-press item.

  • Wait at Main Screen: This is the default setting, and just means that PTFB Pro will wait for you to tell it what to do next.
  • Edit New Item: If you regularly have to tweak an items' properties after creating it, you can speed up the process by selecting this option. The moment you successfully create your next macro or single-press item, PTFB Pro will automatically open up the item for editing, saving you an extra step. (Don't forget though that you can also change the default settings that each new item receives - this might save you even more time)
  • Start Watching: If your new items are usually ready to go as soon as you've created them, select this option. It saves you having to explicitly press "Start Watching" after creating a new item.

Unlock Computer to press targets

Use this option if you frequently lock your computer and/or use a locking screen saver and want PTFB Pro to handle targets even when the computer is locked. After ticking the box, don't forget to enter your logon password in the two edit boxes. PTFB Pro will use this password to briefly unlock then re-lock your computer when a target needs to be pressed.

Note that this option is only available on computers running Windows 2000, XP or 2003 Server, and requires the installation of the optional service component. Certain configuration changes may also be necessary for Windows XP. For more details, please see the section entitled "Working with a locked computer / locking screensaver".

This option is not available when running on Windows Vista, due to its increased security. For more details, please see the section on Windows Vista.


Getting Help

Options -> Configure: Defaults

This page lets you change the default values that are given to a newly-created Single-Press or Macro items. Changes made here do not affect existing items - only new ones that you subsequently create.

The defaults that you can set include the following.

  • Strict vs. simple target window contents checking and other identification options
  • Options for triggering when the target window appears, including: initial press delay, repeat press toggle and delay, hour and day constraints.
  • Command line and macro trigger options. Hotkey triggering is NOT included, as a unique hotkey must be defined for each item.
  • Macro playback speed and redundant mouse-move elimination
  • Email notification toggle, subject line and associated options
  • Logging toggle and associated options

Note that there are situations in which a default you have set may not be applied to a newly created item. For example, the "Fire only for application" setting will not be applied if the application name could not be determined when the item was created.


Getting Help

Options -> Configure: Email

In order to send email notifications, PTFB Pro must have access to an SMTP email server. This can be local (on your network) or on the Internet (assuming you have an always-on connection). This page is used to tell PTFB Pro how to access your outgoing email server, and can also be used to disable email notifications across all your targets.

The details you need to enter are very similar to those required when setting up an account in a typical email program such as Outlook Express. Indeed, you may find that your email program is a useful reference when filling in this page.

Outgoing (SMTP) Server

Enter the address of your SMTP server here. The address can be a four-part IP address (e.g. 127.0.0.1) or an Internet-style name (e.g. smtp.myisp.com)

You can also change the port number used for SMTP communications. In the vast majority of cases you'll leave this at the default value of 25, but it's there if you need it.

Authentication

As a protection against spammers, many Internet Service Providers require you to login before sending an email. If that's the case with your SMTP server, tick the "My server requires authentication" box and enter your login name and password.

In some cases, your ISP may also require that logins be secure (encrypted) - if so tick the box marked "Log on using secure password authentication".

Sender Details

Also as a defense against spammers, SMTP servers typically refuse to send emails unless they have what appears to be a valid sender email address. Obviously you're not going to reply to any email notifications that PTFB Pro sends you(!), but you should nevertheless enter an email address.

If you have any concerns about entering your email address into PTFB Pro, please be assured that PTFB Pro contains no spyware or adware whatsoever, and does not transmit any information over the Internet (other than the emails that you configure it to send).

Recipient

All email notifications that PTFB Pro generates will be sent to this one address. Please take care to enter the correct address, and do not enter the address of any individual who may not wish to receive the notifications.

Test

After you've entered all the necessary settings, it's wise to test them to make sure there are no problems. Click the "Test..." button to send a sample notification to your nominated address.


Getting Help

Options -> Configure: Logging

This page contains settings that will apply to all log entries written out when a target is handled.

Enable Logging

Unless this option is enabled, no targets will be able to generate log entries.

Location

PTFB Pro's text log, and any screenshots taken for log entries or for email notifications, will be stored in a dedicated folder called "PTFBProLog". The location of this folder defaults to a standard location on your computer - the exact path varies according to what operating system you're running, and your current account name. You can alter the location of the folder by clicking the button marked "..." and browsing. PTFB Pro will not move any existing log files, but any new output will be written to the new location.

Size Limit

PTFB Pro will limit the size of the log folder to the value you set here. PTFB Pro checks that the limit hasn't been reached prior to outputting new data, and if it has, all existing log files are archived to a sibling folder called "PTFBProLog.old" (replacing any previous contents). The new screenshot and/or log entry is then written out.

Note that the limit you set is only approximate (PTFB Pro doesn't always know how much space a new screenshot of log entry is going to take before the file has been written).

Screenshots - Format

PTFB Pro offers screenshots in on of two formats: JPEG and PNG. These formats have been chosen because they offer reasonable image quality without excessive file sizes. The default format is JPEG. The format you choose will be used for all subsequent screenshots taken by PTFB Pro.

Screenshots - Delay

As you have no doubt observed, some windows take a short while to redraw when they are brought to the front from behind other windows. This depends on many factors, including the speed of your computer, the amount of work your computer is currently doing, and the size and complexity of the window that has to be drawn.

PTFB Pro has to take a screenshot before it takes the action(s) set in the target you've defined, since the action(s) may close the window in question! Unfortunately, this means that the screenshot may be taken while the window is in a partially-drawn state. You can make PTFB Pro wait a certain amount of time before it takes a screenshot, in the hope that the window will have time to finish drawing.

For the reasons already stated, this is not an exact science, and you may have to adjust the delay a few times before you get complete screenshots. Furthermore, the longer the delay before a screenshot takes place, the longer PTFB Pro will take to carry out the appropriate press/macro.

The screenshot option is primarily intended to help people who want a complete record of what has been happening on their computer while they're away from it.


Getting Help

Options -> Configure: Don't Show This Again

PTFB Pro occasionally displays confirmation screens to help avoid accidents and to give helpful information. In most cases, these screens have a checkbox that reads "Do not show this again". If you tick this box, PTFB Pro will remember your response to the screen and won't trouble you with it again.

Occasionally, you may tick the box then later wish to have the associated confirmation screen show up again. This oddly named page lets you do just that.

Each entry in the list represents a confirmation screen that you have chosen to suppress. If you select an entry and delete it from the list, PTFB Pro will be free to show that confirmations screen (or one very similar to it) the next time it is appropriate.


Command Line Options

PTFB Pro responds to the following command line options.

  1. Empty command line
    Launches PTFB Pro if it is not already running. If PTFB Pro is already running, it opens up the main window.
  2. Up to two, four-digit item IDs
    In the fully licensed version, triggers the items with the specified IDs. See help for Item Properties Triggers Page for more details.
  3. /RELOAD
    If PTFB Pro is already running, causes all items to be reloaded from the data file. Useful when distributing a new copy of the data file to multiple installations.
  4. /NOICON
    Causes PTFB Pro to run WITHOUT its system tray icon.

    To open up PTFB Pro's main window when it is running in this state, please launch PTFB Pro again via the Start Menu, desktop or quick-launch icons.

    If you wish PTFB Pro to start automatically without its icon, please DISABLE the inbuilt "Run at Startup" option, and create a shortcut in the Startup folder of your Start Menu, specifying the /NOICON directive on the command line.


Automating Button Pushing - Tweaking the Settings

Working with a locked computer / locking screensaver

[Limited to Windows 2000, Windows XP and 2003 Server. NOT available for Windows Vista]

In the past, PTFB was often unable to press targets when the computer was in a locked state. This is because Windows has tunnel vision when the computer is locked: it will let you log back in, but any mouse or keyboard activity not related to the logon is ignored.

In version 3, you can instruct PTFB Pro to briefly unlock your computer when it sees a target. The computer is automatically re-locked as soon as the target has been handled - in most cases this means that the unlock/press/re-lock process is completed in a little over a second.

Caution

Please note that the automatic unlock function by its very nature reduces the security of the computer on which it runs. The time between the unlock and re-lock is dependent on the speed of execution of the actions you have set PTFB Pro to carry out. A skilled attacker could conceivably abuse the unlock function and use it to take control of the computer. Equally, a system failure at the wrong moment could leave the computer unlocked. For this reason, we recommend using it only in cases where the locked state is non-critical.

How to set up PTFB Pro for automatic unlocking / re-locking

1. Install PTFB Pro with the optional workstation unlocking service

This option is turned off by default - if you didn't tick it when you installed PTFB Pro, you won't have the service. To install the service, just run the installer again and tick the "Install Workstation Unlocking Service" box when you see it. There's no need to uninstall first, but you should quit PTFB Pro to avoid a file-in-use error.

Please note that you can only install and use the service under an account with administrative privileges.

2. Tick "Unlock computer to press targets"

This is on the General page of the PTFB Pro Configuration screen, off the Options dropdown menu.

3. Enter the logon password, and confirm it

Type your logon password into the two boxes provided, then press Close to save your changes. The password you supply will be stored in an encrypted form to preserve security.

4. Disable Fast User Switching (applies to Windows XP only)

Windows XP introduced "fast user switching", and with it, a new style of logon known as the "Welcome" screen . These are enabled by default on a stand-alone computer, but typically disabled in a domain environment. For best results, we recommend disabling fast user switching, thus causing Windows to revert to the classic logon screen.

To disable fast user switching, choose "User Accounts" from the control panel, then select "Change the way users log on or off". Now untick "Use Fast User Switching" and hit Apply Options to save changes.

If you don't want to give up fast user switching, you can easily test whether it will cause a problem for the unlock service. Just lock your computer using the <Windows key> + L key sequence (or by typing "Rundll32.exe user32.dll,LockWorkStation" into the Run box), and observe whether the password box for your account is displayed by default. If it is, then the service should be able to unlock the computer as and when required. If not, you will need to disable fast user switching.

For Administrators : more information about the unlocking service

The service appears in the service manager as "PTFB Pro Workstation Unlock Svc". It is set to run under the local system account, and is allowed to interact with the desktop.

The service's startup type is "manual". This is because PTFB Pro only starts the service when it is required to unlock the computer. As soon as the unlock has completed, the service stops automatically. This is why PTFB Pro has to run under an administrator account for the unlock to succeed - a lesser user account is unable to start the service on demand.

After unlocking the computer, PTFB Pro waits for a short amount of time before carrying out the actions you've defined. This pause allows the system to clear away the logon screen and present the user desktop. On slow or heavily loaded computers, Windows might not have fully restored the desktop by the time PTFB starts pressing buttons. This could affect the success of the button presses for some targets. You can tweak the post-unlock pause with the regsitry edit below - but please do not attempt this unless you are used to manipulating the registry. Careless registry editing can damage your Windows installation and may even cause data loss.

To change the post-unlock wait period, add a new DWORD value called LogonWait below the key HKLM\SOFTWARE\TLHouse\PTFBPro. Set the value in millisecs up to a maximum of 1500 (one and a half seconds). For reference, the default pause is 500 (half a second).

Finally, service activities (startup, shutdown and errors) are recorded in the application event log.


Troubleshooting

This section contains answers to frequently asked questions and common problems. If you don't find what you're looking for in here, please feel free to post to our PTFB Support Forums or send an email to support@ptfbpro.com

How do I stop the recording or playback of a macro?

PTFB Pro won't press anything! (Zone Alarm and other protection software)

I want to import targets from an old PTFB installation. How do I do it?

I want to move PTFB Pro to my new computer, but I don't know how to do it

I told PTFB Pro not to show a confirmation screen again - how do I get it back?

How do I find out how many days are left on the trial?

PTFB Pro pressed the target once, but hasn't done it since?

My macro triggers OK, but doesn't always do the right thing

I've defined a hotkey for an item, but nothing happens when I use it!

I've used "By Prompt" checking - the text IS in the window, but PTFB Pro doesn't see it?

I've password-protected PTFB Pro, but I've forgotten the password

PTFB Pro is too slow / takes too much cpu time

PTFB Pro is seeing the target, but is failing to take appropriate action

Automatic workstation unlocking isn't working

Every time my computer starts up, PTFB Pro's window is open and I have to press Start Watching

When I try to record a macro, PTFB Pro seems to hang

During playback, some macros occasionally get "stuck"

How do I stop the recording or playback of a macro?

Both recording and playback can be stopped by tapping the Pause/Break key (usually found next to the Scroll Lock and Print Screen keys) OR by holding down CTRL and tapping Escape (Esc). The latter may also bring up the Start menu - just hit the Esc key again to dismiss it.

If one method doesn't work for any reason, use the other!

PTFB Pro won't press anything! (Zone Alarm and other protection software)

Zone Alarm and certain other protection software may see PTFB Pro's activities as suspicious and block them. In some case the software might not tell you that it is taking this blocking action!

The solution is to configure your protection software to make an exception for PTFB Pro (e.g. add PTFBPro.exe to the software's "trusted" list). In Zone Alarm for example, this is done in the Program Control section.

I want to import targets from an old (version 1.x) PTFB installation. How do I do it?

There's a special command in the Options menu to do just this. Click on this link for details

I want to move PTFB Pro to my new computer, but I don't know how to do it

PTFB Pro stores preferences in the registry, but all the targets you've defined are held in one file called PTFBPro3.dat, and their screenshots are held alongside in .jpg files. The exact path to these files depends on what operating system you're running, and what account you installed PTFB Pro under.

To save problems, the following procedure is recommended:

  1. Quit PTFB Pro on your old computer
  2. Install PTFB Pro on your new computer and run it. This causes PTFB Pro to create the folder that will hold the data file
  3. Quit PTFB Pro on the new computer, so that it won't interfere with the transfer
  4. On both computers, go to the Start menu and and select "Run..". Type the following into the run box, without the quotes: "%appdata%". This should open up a window that displays the contents of your general Application Data folder. Drill down inside the Technology Lighthouse folder, then inside the PTFBPro folder.
  5. Copy the contents from the PTFB Pro folder on the old computer to the corresponding folder on the new computer, overwriting as necessary.
  6. All that now remains is to re-make any important configuration changes on your new computer, e.g. re-enter your SMTP server details, enable/disable icon hiding etc.

    If you're completely confident about registry editing, you could do this by exporting the following registry key (and subkeys and values) to a .reg file, then re-importing it on the new computer. DO NOT ATTEMPT THIS unless you're experienced at manipulating the registry.

    HKCU/Software/TLHouse/PTFBPro

Note#1: If your computer doesn't understand the "%appdata%" directive (older operating systems may not), then the best approach is to pull up Search from the Start menu and search for PTFBPro3.dat. Remember to enable options such as "Search subfolders" and "Search hidden files and folders" if they are present.

Note#2: On some computers Windows may hide files from you. This is meant to be for your protection, but in this case it's... an irritation. If at any point you see an empty folder but there's a link titled "Show entire contents" or similar, click it!

I told PTFB Pro not to show a confirmation screen again - how do I get it back?

Just open up the PTFB Pro Configuration property sheet, and switch to the "Don't Show This Again" page. Click here for more details.

How do I find out how many days are left on the trial?

This information is displayed in PTFB Pro's About screen. There's a command to view the About screen in the Options menu.

PTFB Pro pressed the target once, but hasn't done it since?

This is most likely because the target window changes subtly each time it appears. The changes may involve the window title, certain hidden attributes, or the window's contents. You can fix this by tweaking settings on the Identifying the Target page of the properties for your target. Options to consider changing include: switching to "Require This Text" for the main window section, turning off Type checking for the main window, and choosing "Simple" or "By Prompt" for the window contents section.

My macro triggers OK, but doesn't always do the right thing

Macros involving mouse actions depend on everything within a window holding the same position. Equally, commands such as Paste depend on the current contents of the clipboard. Or it may just be that the macro is playing back faster than the target program can handle.

Please read the section Tips for Macros for more information.

I've defined a hotkey for an item, but nothing happens when I use it!

There are several possibilities here:

  1. The target window is either not present, or is not being recognized by PTFB. If the target window is on-screen, then open the item's properties and switch to the "Identifying the Target" page. The Help for that page has a number of useful tips, but for many cases just switch from "Strict" to "Simple" contents checking does the trick!
  2. The item is disabled - enable it to re-instate the hotkey.
  3. PTFB Pro is minimized to the system tray and in the disabled state (maybe you've chosen "Disable PTFB" from the tray icon's menu?)
  4. The hotkey you've defined has been hijacked by another program. Bring up the item's properties, go back to the Triggers page and clear the hotkey checkbox. Now tick the checkbox again and re-define the hotkey.

I've used "By Prompt" checking - the text IS in the dialog, but PTFB Pro doesn't see it?

PTFB Pro can't necessarily "see" the same text you can. If the target window is simply drawing text on the screen, or uses non-standard Windows controls, then PTFB Pro won't be able to read it. You'll need to pick text that PTFB Pro can see (check the Info page of your target's properties for a list) or choose a different checking method.

I've password-protected PTFB Pro, but I've forgotten the password

The password is stored in the registry. If you remove the appropriate registry entry, you'll clear the password and regain access to PTFB Pro. The usual caveat applies - do not touch the registry unless you have prior experience of registry editing. If you want to play it safe, email support@ptfbpro.com instead.

For those who are comfortable with registry editing, proceed to the following key:

HKEY_CURRENT_USER/Software/TLHouse/PTFBPro/Options

...and delete the value named "Password".

PTFB Pro is too slow / takes too much cpu time

If PTFB Pro is taking too long to react to a target:

    • First check the target's Properties and make sure the delay is set to zero. For more details, please see the help for the Triggers page.
    • Check the Notification page of the target's Properties to see if a screenshot is being taken, either for logging or for email. If so, PTFB Pro will delay any action in order to take the screenshot. The screenshot facility is really intended for use when you'll be away from your computer.
    • Try a faster response speed in the General page of the PTFB Pro Configuration property sheet.

If PTFB Pro is taking too much CPU time, there are several things to try:

    • Disable or delete any target entries you no longer need. The more targets PTFB Pro has to check, the more work it has to do.
    • If "Defeat Icon Hiding" is enabled in the General page of the PTFB Pro Configuration property sheet, disable it and use the taskbar properties to tell XP not to hide PTFB Pro's tray icon instead.
    • Turn off logging, screenshots, commands and email notifications for your targets if you don't really need them.
    • Reduce the response speed in the General page of the PTFB Pro Configuration property sheet

PTFB Pro is seeing the target, but is failing to take appropriate action

You've verified that PTFB Pro is seeing the target by using a five second delay and watching for a red border around PTFB Pro's tray icon, but the actual macro/press isn't working...

    • First check that your protection software isn't blocking PTFB Pro's activities
    • Also check that there are no "always on top" windows floating above the the target. If there are, they will intercept PTFB Pro's simulated mouse and key presses.
    • If the item in question is the "Single Press" type, try recreating it as a Macro (and vice-versa).
    • If the target in question is the Macro type, try reducing the playback speed, or disable elimination of redundant mouse movement. Also, try recreating the Macro but start it by clicking in the window to make sure it gets focus early on.
    • Likewise, if you're getting PTFB Pro to simulate mouse activities, but the same task can be accomplished via the keyboard, try the keyboard approach, and vice-versa.

Automatic workstation unlocking isn't working

    • Make sure the option is enabled (Options->Configure, General page)
    • Make sure PTFB Pro has been given the correct logon password (General page, as above)
    • On Windows XP, make sure that your computer is not using the Welcome page when it is locked. See the section on fast user switching here.
    • Make sure the service is set to manual startup, uses the local system account and is allowed to interact with the desktop.
    • Make sure you're running PTFB Pro under an administrator account, or an account with sufficient privileges to start/stop services.

Every time my computer starts up, PTFB Pro's window is open and I have to press Start Watching

The most likely explanation is that PTFB Pro is being asked to launch more than once. If PTFB is running in the tray and it is launched again, it opens up the main window and you must press Start Watching to close it. This is by design.

To check for multiple startups, do the following:

  1. Type MSCONFIG into the Run... box off the Start Menu
  2. Switch to the Startup tab
  3. Scroll through the list looking for entries relating to PTFB Pro. You should see exactly one entry for "PTFBStart" in the Run key of the registry. If you see any other entries, like a shortcut in the Startup folder off the Start Menu, then you've found the culprit!

When I try to record a macro, PTFB Pro seems to hang

If your computer is running Windows XP or Windows 2000, this could be because of a conflict with mouse drivers (or drivers for another device, such as a touchpad or trackball).

The first thing to remember is that if this happens you can usually abort the recording by holding down CTRL and tapping the Escape (Esc) key.

To fix the problem, you have two options:

1) Change PTFB Pro's recording/playback method

A new recording/playback method was developed for Microsoft's new operating system, Windows Vista. This method can also be used on Windows 2000 and Windows XP, but it does involve a small registry tweak. If you're not comfortable editing the registry, this is probably not for you. And even if your are a wiz with RegEdit, always remember that editing the registry must be done very carefully, as mistakes can damage your Windows installation. Sole responsibility lies with you!

Warnings aside, if you want to try this, here's how:

  1. Quit PTFB Pro. You must be absolutely sure that PTFB Pro isn't running or the registry tweak will have no effect.
  2. Run RegEdit (just type RegEdit into the Run box off the Start Menu)
  3. Locate the HKEY_CURRENT_USER top-level key, and begin navigating down through the following path: HKEY_CURRENT_USER\Software\TLHouse\PTFBPro\Options
  4. With the Options key selected, you should see a variety of values, but you're looking for just one: "ForceVistaMode"
  5. Double-click on ForceVistaMode and change its value from 0 (the default) to 1
  6. Close RegEdit and re-launch PTFB Pro

If you try this but don't like it for any reason, you can easily switch back by following the above steps but setting ForceVistaMode back to 0. Also note that this is a per-account setting. It'll affect only you. If other people use the same computer under different accounts and also want to use the Vista method for macros, they'll have to log on and perform the same steps.

2) Locate the cause of the conflict and update/remove it

It's hard to provide a step by step method for troubleshooting this problem - only you know what hardware and software is installed on your computer, but the hopefully the following guide will give you some ideas.

  • Try booting into Safe-mode (hold down F8 during a boot and select Safe Mode from the menu). This causes Windows to start up (for this session only) without a lot of the software and drivers that normally run. Try launching PTFB Pro in this state and see if the problem still occurs. If it doesn't, then you know the conflict is caused by something that is not currently running. If the conflict is still there, then it has to be caused by one of the very few items that are still present, or by a corrupt, incomplete or otherwise damaged Windows installation. Some "lite" or customized Windows installations are actually lacking vital core components.
  • Once you've got a short-list of suspects, try to eliminate them in a stepwise, logical way by disabling or removing one of them at a time and re-testing.
  • If you have another computer to hand, try PTFB Pro on it. If the problem doesn't occur, then you know the problem is related to something that is different between the two machines.
  • When you locate the culprit, the solution may be to delve into its configuration (if it has such an option) or to check the manufacturer's site to see if there's a newer version of the software/driver that may fix the problem.

During playback, some macros occasionally get "stuck"

Much like hangs during recording, this is usually caused by conflicting software/drivers. The steps for resolution are the same too.


Vista

Special Notes for Windows Vista

Microsoft's new Vista operating system brings a lot of changes that are designed to increase your computer's security. Unfortunately, these changes can sometimes get in the way of your daily work. The following section provides some hints and tips for taming Vista.

Privileges and the Elevation Prompt

Windows Vista runs most programs with "reduced privileges". This restricts what they can do, to help keep your computer safe.

Some programs have to run without these restrictions in order to do their job. When you run one of these programs, Windows Vista asks your permission via the so-called "Elevation Prompt":

The first thing to say about this screen is that Microsoft have gone to great lengths to stop other programs from pressing its buttons. That includes PTFB Pro. So for the time being at least, PTFB Pro cannot dismiss this prompt for you.

If you find the prompt really irksome, then you have a few of choices:

1) Turn off UAC (User Account Control), the system component that is responsible for the prompt. This might provide blissful relief, but it disables a huge chunk of the operating system that is designed to protect your computer. In short, turning off UAC is NOT recommended.

2) Tweak UAC settings to reduce the the level of annoyance, while retaining some measure of security. Possible tweaks are suggested in the section "Steps for an easier life in Vista", but be aware that these steps may reduce the security of your computer. The choice, and the associated risks, are yours.

3) Have a beer, and try to put up with it. However, be aware that this solution could lead to a long-term dependency on alcohol. It wouldn't be the first time that Windows has driven someone to drink.

If you do change the UAC settings, you might see a balloon popping up from the Windows Security Alerts icon in the system tray. The Windows Security Center (in the control panel) allows you to change this - "Change the way security center alerts me". Alternatively, you can use a Single-Press to get rid of this whenever it appears - click here for more details.

Steps for an easier life in Vista

The following suggestions are intended only for computer-savvy people who run under a local administrator account, frequently use programs with higher privileges and don't mind lowering the UAC settings a little. Please be aware that this means reduced security on your computer - if you choose to follow these steps, you assume complete responsibility for any problems that may result.

So with the warnings over, here's how to keep Vista's interference to a minimum, while retaining a fair chunk of the security improvements:

  1. Launch the local security policy editor by typing"secpol.msc" into the search box off the Start Menu, and drill down to Local Policies->Security Options. Scroll down until you see all the User Account Control settings.
  2. In the local security policy, change "User Account Control: Behavior of the elevation prompt for administrators in Admin Approval Mode" to "elevate without prompting". This gets rid of the elevation prompt, but retains the separation between programs running with different privilege levels.
  3. Also in the local security policy, consider changing "User Account Control: Only elevate executables that are signed and validated" to "Enabled". This is actually an increase over the default settings, and may cause problems with some older software, but it helps to compensate for the loss of the elevation prompt since it's not often that malware is digitally signed.


Troubleshooting

A few words of caution...

PTFB Pro can greatly reduce the daily irritations and interruptions that your computer throws at you. But, like many tools, it can also be dangerous if not used with care.

PTFB Pro will not question you if tell it to immediately answer "Yes" to a dialog that reads "Do you really want to reformat this disk?"

If that scenario seems too far fetched, what about this one. You regularly use your favorite text editor as a scratch-pad. The text you enter is junk five minutes after you've typed it, but the editor still prompts you to save when you try to quit. So you set up PTFB Pro to handle it, and all is well. But one day you type something important - maybe a phone number you want to keep, then accidentally close your editor. The editor prompts to save but... you can guess the rest.

Take particular care when recording macros - they are more powerful than simple button presses, and potentially more dangerous!

Additionally, think carefully before enabling the automatic workstation unlocking function. Make sure you've read the caution in the appropriate section (click here) and understand the risks.

Finally please enjoy the feeling of empowerment that comes from seeing PTFB Pro go about its work, but at the same time exercise appropriate care. Responsibility for accidents lies with you, not with this program!


Tray Notification Balloons

Dismissing System Tray Notification "Balloons"

System tray balloons such as the one below were originally used as a way of alerting you without getting in the way of your current task.

Unfortunately, they can be an annoying distraction if they're not carrying relevant information. For example if you temporarily turn off XP's inbuilt firewall to troubleshoot a network problem, you'll get a balloon pointlessly telling you what you've just done. A battle of wills between you and the computer now ensues: can you ignore the balloon until it closes, or will you succumb and interrupt your troubleshooting to hit the balloon's close box? Of course you could just disable such warnings completely, but that's generally not a good idea.

Happily, PTFB Pro can now dismiss these tedious little attention seekers. Here's how:

  1. When the balloon next appears, create a new single-press item (not a macro)
  2. Target the single press item on the balloon's close box

The resulting item can be edited just like any other. You can for example set a trigger delay of 1 to 2 seconds so that you get to read the notification, but it closes before it becomes an irritation. The only difference is that on the General page of the item's properties, the Action section now carries an explicit "Close Tooltip" option.

Points to note:

If you're running on a 64-bit version of the operating system (XP 64, Vista 64), PTFB Pro will not be able to extract the text of the tooltip. In this case, we recommend tightening the settings on the target identification page as much as possible - e.g. turn on "match window size". Note that this applies only to 64-bit versions of the operating system, NOT the more common case of 64-bit hardware running a 32-bit operating system.


Configuration - Hotkeys

Options -> Configure: HotKeys

Hotkeys are short key combinations that trigger a command. They're just an alternative to using the mouse, but many people find them faster and less distracting. For example, Windows uses "F1" to call up Help for the program you're currently using, and CTRL+ALT+DELETE to summon the task manager in Windows XP onwards.

You can define hotkeys for several of PTFB Pro's main functions, and for manually triggering macros and single-press items. The dedicated "HotKeys" page shown below (Options menu -> Configure... -> HotKeys) is the easiest place to view and change all the hotkeys for PTFB Pro.

Before you get started with your own hotkey definitions, please note the following:

  1. In Windows, a hotkey is "global". Only one program can lay claim to a specific key combination at a time. If some other program has already taken your ideal combination, e.g. CTRL+SHIFT+R, for one of its functions, then you won't be able to define that hotkey within PTFB Pro - at least not while the other program is running.
  2. Take a little care when choosing a key combination. Try not to pick keys that you - or others who share the same computer - may associate with another function. For example CTRL+P is synonymous with "Print" in many programs. If you define CTRL+P as "Create new Single-Press Item", you'll find that CTRL+P will always do that as long PTFB Pro is running, regardless of what program you're currently using. Don't worry though - if you don't like a hotkey you've created, you can always clear it or disable it.

The hotkeys page is split into two sections. The upper section deals with PTFB Pro's functions. For example, you can define a hotkey to toggle PTFB Pro between enabled and disabled, or to run the currently selected macro. The lower section is dedicated to the macro and single-press items you've created. You can define a separate hot key for each item that triggers it on demand.

To define a hotkey, just double-click the appropriate function or item and then type the key combination into the resulting screen. If the key combination isn't available, it'll be ignored. Once you type a combination that is available, it'll be set automatically. If you want to clear a combination, select it in the appropriate list and hit the adjacent Clear button.

Here are some other points worth noting:

  • To temporarily disable a hotkey, just untick it. Ticking the box will re-enable it when you're ready.
  • If a hotkey should be enabled but its checkbox is showing an indistinct state (neither ticked nor unticked), try hovering the mouse over it. A tooltip will tell you why PTFB Pro was unable to fully activate the hotkey.
  • If a macro or single-press item is disabled, then any hotkey you define for it will not be active until you re-enable the item itself
  • You can also define hotkeys for macros and single-presses from within their property screens (Edit -> Triggers page)


View Log

Options -> Configure: View Log

This page displays the current contents of PTFB Pro's text log file, sorted with the most recent entries at the top.

If any entry has a non-blank screenshot column (denoted by the graphic icon), you can view the screenshot by selecting the entry and clicking "View Screenshot" at the bottom of the page.

Clicking Refresh causes the text log to be reloaded, and finally clicking Empty Log moves all the current log files (text and screenshots) to the "PTFB Pro Log.old" folder, replacing any previous old files.


Automating Button Pushing - Tweaking the Settings

Target Properties - Notification

Sometimes it's useful to have a record of windows that PTFB Pro has handled. For example, if you're getting annoying error reports from a program, you can have PTFB Pro dismiss them quickly, but still record the error text each time. That way you can get on with your work, but still have enough information to troubleshoot the problem later on.

When PTFB Pro handles a target window, you can have it take any/all of the following actions:

  • Email you with a screenshot and details collected from the target window
  • Write equivalent information to a text log
  • Run a script or program of your choosing

Send Email

If you have access to an outgoing SMTP server (whether it's on your network, or available through your persistent internet connection) you have PTFB Pro send you an email each time the target is handled.

You can set the subject line for the email, include prompt text collected from the target window, and attach a screenshot of the target window.

The format of the screenshot (if any) is set for all targets via the PTFB Pro Configuration property sheet, as are the details of the outgoing email server. If you tick "Send Email" but haven't yet entered your SMTP server details, you'll be prompted to do so now. Bear in mind that disabling email notifications in the PTFB Pro Configuration property sheet will prevent any emails going out, regardless of individual target settings.

Write To Log

PTFB Pro creates a folder on you computer for storing its text log and screenshots. The location of this folder is set in the PTFB Pro Configuration property sheet. If you select "Write To Log" an entry will be made in the text log each time PTFB Pro handles the target window. Optionally, you can have PTFB Pro take a screenshot (referencing it in the log entry) and include the target's prompt text in the log entry.

As with emails, no logging will occur for any targets if the "Enable Logging" option is turned off in the PTFB Pro Configuration sheet.

Run Script or Program

If you give PTFB Pro a command (similar to a command you might enter into the Windows "Run" box, or in a Command Prompt window), it will run it shortly after the target fires.

To help you compose the command, you can drag files into the "Cmd Line" edit box, or use the Browse facility. Click the "Test Now" button to check that you've got the command right.

Note: When you drag files into the "Cmd Line" edit box they will be appended to the current contents.